import{S as a$,i as s$,s as i$,e as s,k as l,w as f,t as o,M as r$,c as i,d as t,m as p,a as r,x as u,h as a,b as d,N as o$,G as e,g as c,y as _,q as h,o as v,B as b,v as l$,L as Va}from"../../../chunks/vendor-hf-doc-builder.js";import{D as R}from"../../../chunks/Docstring-hf-doc-builder.js";import{C as M}from"../../../chunks/CodeBlock-hf-doc-builder.js";import{I as U}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Xa}from"../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function p$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFPipeline, IFSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch

pipe = IFPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.enable_model_cpu_offload()

prompt = 'a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says "very deep learning"'
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

image = pipe(prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type="pt").images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image, prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type="pt"
).images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

safety_modules = {
    "feature_extractor": pipe.feature_extractor,
    "safety_checker": pipe.safety_checker,
    "watermarker": pipe.watermarker,
}
super_res_2_pipe = DiffusionPipeline.from_pretrained(
    "stabilityai/stable-diffusion-x4-upscaler", **safety_modules, torch_dtype=torch.float16
)
super_res_2_pipe.enable_model_cpu_offload()

image = super_res_2_pipe(
    prompt=prompt,
    image=image,
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFPipeline, IFSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&#x27;a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says &quot;very deep learning&quot;&#x27;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type=<span class="hljs-string">&quot;pt&quot;</span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image, prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>safety_modules = {
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;feature_extractor&quot;</span>: pipe.feature_extractor,
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;safety_checker&quot;</span>: pipe.safety_checker,
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;watermarker&quot;</span>: pipe.watermarker,
<span class="hljs-meta">... </span>}
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_2_pipe = DiffusionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;stabilityai/stable-diffusion-x4-upscaler&quot;</span>, **safety_modules, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_2_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_2_pipe(
<span class="hljs-meta">... </span>    prompt=prompt,
<span class="hljs-meta">... </span>    image=image,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function d$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFPipeline, IFSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch

pipe = IFPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.enable_model_cpu_offload()

prompt = 'a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says "very deep learning"'
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

image = pipe(prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type="pt").images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image, prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFPipeline, IFSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&#x27;a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says &quot;very deep learning&quot;&#x27;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, output_type=<span class="hljs-string">&quot;pt&quot;</span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image, prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function m$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch
from PIL import Image
import requests
from io import BytesIO

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image.resize((768, 512))

pipe = IFImg2ImgPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0",
    variant="fp16",
    torch_dtype=torch.float16,
)
pipe.enable_model_cpu_offload()

prompt = "A fantasy landscape in style minecraft"
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

image = pipe(
    image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
).images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFImg2ImgSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0",
    text_encoder=None,
    variant="fp16",
    torch_dtype=torch.float16,
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = original_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFImg2ImgPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>,
<span class="hljs-meta">... </span>    variant=<span class="hljs-string">&quot;fp16&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape in style minecraft&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFImg2ImgSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>,
<span class="hljs-meta">... </span>    text_encoder=<span class="hljs-literal">None</span>,
<span class="hljs-meta">... </span>    variant=<span class="hljs-string">&quot;fp16&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image,
<span class="hljs-meta">... </span>    original_image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function c$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch
from PIL import Image
import requests
from io import BytesIO

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image.resize((768, 512))

pipe = IFImg2ImgPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0",
    variant="fp16",
    torch_dtype=torch.float16,
)
pipe.enable_model_cpu_offload()

prompt = "A fantasy landscape in style minecraft"
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

image = pipe(
    image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
).images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFImg2ImgSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0",
    text_encoder=None,
    variant="fp16",
    torch_dtype=torch.float16,
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = original_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFImg2ImgPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>,
<span class="hljs-meta">... </span>    variant=<span class="hljs-string">&quot;fp16&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape in style minecraft&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFImg2ImgSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>,
<span class="hljs-meta">... </span>    text_encoder=<span class="hljs-literal">None</span>,
<span class="hljs-meta">... </span>    variant=<span class="hljs-string">&quot;fp16&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image,
<span class="hljs-meta">... </span>    original_image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function g$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch
from PIL import Image
import requests
from io import BytesIO

url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image

url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png"
response = requests.get(url)
mask_image = Image.open(BytesIO(response.content))
mask_image = mask_image

pipe = IFInpaintingPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16
)
pipe.enable_model_cpu_offload()

prompt = "blue sunglasses"
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

image = pipe(
    image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
).images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFInpaintingSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image,
    mask_image=mask_image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = original_image

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content))
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = mask_image

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFInpaintingPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;blue sunglasses&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    image=original_image,
<span class="hljs-meta">... </span>    mask_image=mask_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFInpaintingSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image,
<span class="hljs-meta">... </span>    mask_image=mask_image,
<span class="hljs-meta">... </span>    original_image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function f$(Y){let y,N,L,I,S;return I=new M({props:{code:`from diffusers import IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch
from PIL import Image
import requests
from io import BytesIO

url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image

url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png"
response = requests.get(url)
mask_image = Image.open(BytesIO(response.content))
mask_image = mask_image

pipe = IFInpaintingPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16
)
pipe.enable_model_cpu_offload()

prompt = "blue sunglasses"

prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)
image = pipe(
    image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
).images

# save intermediate image
pil_image = pt_to_pil(image)
pil_image[0].save("./if_stage_I.png")

super_res_1_pipe = IFInpaintingSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
super_res_1_pipe.enable_model_cpu_offload()

image = super_res_1_pipe(
    image=image,
    mask_image=mask_image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
).images
image[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>original_image = original_image

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content))
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_image = mask_image

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = IFInpaintingPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;blue sunglasses&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    image=original_image,
<span class="hljs-meta">... </span>    mask_image=mask_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># save intermediate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image = pt_to_pil(image)
<span class="hljs-meta">&gt;&gt;&gt; </span>pil_image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe = IFInpaintingSuperResolutionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>super_res_1_pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span>image = super_res_1_pipe(
<span class="hljs-meta">... </span>    image=image,
<span class="hljs-meta">... </span>    mask_image=mask_image,
<span class="hljs-meta">... </span>    original_image=original_image,
<span class="hljs-meta">... </span>    prompt_embeds=prompt_embeds,
<span class="hljs-meta">... </span>    negative_prompt_embeds=negative_embeds,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),{c(){y=s("p"),N=o("Examples:"),L=l(),f(I.$$.fragment)},l(g){y=i(g,"P",{});var O=r(y);N=a(O,"Examples:"),O.forEach(t),L=p(g),u(I.$$.fragment,g)},m(g,O){c(g,y,O),e(y,N),c(g,L,O),_(I,g,O),S=!0},p:Va,i(g){S||(h(I.$$.fragment,g),S=!0)},o(g){v(I.$$.fragment,g),S=!1},d(g){g&&t(y),g&&t(L),b(I,g)}}}function u$(Y){let y,N,L,I,S,g,O,Ha,Qm,Bp,Se,st,Ya,Vt,Zm,Ja,ec,zp,No,tc,Wp,ie,Ka,nc,oc,Qa,ac,sc,Ht,ic,Yt,rc,lc,Xp,Re,it,Za,Jt,pc,es,dc,Vp,Mo,mc,Hp,re,Kt,cc,Qt,gc,fc,uc,Zt,_c,en,hc,vc,bc,Go,Ic,ts,yc,Yp,tn,Jp,Uo,wc,Kp,nn,Qp,rt,Pc,on,Ec,Fc,Zp,lt,$c,ns,jc,xc,ed,an,td,Ao,kc,nd,G,os,Bo,qc,Dc,as,zo,Tc,Cc,ss,Wo,Oc,Lc,is,Xo,Sc,Rc,rs,Vo,Nc,Mc,ls,Ho,Gc,od,Yo,ps,Uc,ad,le,sn,ds,ms,Ac,Bc,Ne,cs,rn,zc,Wc,gs,ln,Xc,Vc,fs,pn,Hc,Yc,dn,us,_s,Jc,Kc,mn,hs,cn,Qc,Zc,vs,gn,eg,tg,fn,bs,Is,ng,og,ys,ws,un,ag,sd,pt,Ps,sg,ig,_n,Jo,Zy,id,dt,Es,rg,lg,hn,Ko,e2,rd,Me,mt,Fs,vn,pg,$s,dg,ld,ct,mg,bn,cg,gg,pd,In,dd,Ge,gt,js,yn,fg,xs,ug,md,pe,_g,Qo,hg,vg,Zo,bg,Ig,cd,ae,ks,yg,wg,qs,Pg,Eg,ea,Fg,$g,gd,wn,fd,Ue,ft,Ds,Pn,jg,Ts,xg,ud,de,kg,ta,qg,Dg,na,Tg,Cg,_d,se,Cs,Og,Lg,Os,Sg,Rg,oa,Ng,Mg,hd,En,vd,Ae,ut,Ls,Fn,Gg,Ss,Ug,bd,_t,Ag,Rs,Bg,zg,Id,$n,yd,Be,ht,Ns,jn,Wg,Ms,Xg,wd,aa,Vg,Pd,xn,Ed,sa,Hg,Fd,vt,Yg,Gs,Jg,Kg,$d,kn,jd,bt,Qg,Us,Zg,ef,xd,qn,kd,ia,tf,qd,Dn,Dd,me,nf,ra,As,of,af,Bs,sf,rf,Td,Tn,Cd,ze,It,zs,Cn,lf,Ws,pf,Od,la,df,Ld,pa,mf,Sd,On,Rd,da,cf,Nd,Ln,Md,ma,gf,Gd,Sn,Ud,ca,ff,Ad,Rn,Bd,We,yt,Xs,Nn,uf,Vs,_f,zd,wt,Hs,Xe,Ys,hf,vf,Js,bf,If,ga,yf,wf,A,Ve,Ks,Mn,Pf,Ef,Qs,Zs,Ff,$f,fa,jf,xf,He,ei,Gn,kf,qf,ti,ni,Df,Tf,ua,Cf,Of,Ye,oi,Un,Lf,Sf,ai,si,Rf,Nf,_a,Mf,Gf,Je,ii,An,Uf,Af,ri,li,Bf,zf,ha,Wf,Xf,Ke,pi,Bn,Vf,Hf,di,mi,Yf,Jf,va,Kf,Qf,Qe,ci,zn,Zf,eu,gi,fi,tu,nu,ba,ou,Wd,Ze,Pt,ui,Wn,au,_i,su,Xd,B,Xn,iu,ce,Vn,ru,hi,lu,pu,Et,du,Ft,Hn,mu,J,cu,vi,gu,fu,bi,uu,_u,Ii,hu,vu,yi,bu,Iu,yu,$t,Yn,wu,Jn,Pu,wi,Eu,Fu,$u,ge,Kn,ju,Pi,xu,ku,w,qu,Ei,Du,Tu,Fi,Cu,Ou,$i,Lu,Su,ji,Ru,Nu,xi,Mu,Gu,ki,Uu,Au,qi,Bu,zu,Di,Wu,Xu,Ti,Vu,Hu,Ci,Yu,Ju,Oi,Ku,Qu,Li,Zu,e_,Si,t_,n_,Ri,o_,a_,Ni,s_,i_,Mi,r_,l_,Gi,p_,d_,Ui,m_,c_,Ai,g_,f_,Bi,u_,__,zi,h_,v_,Wi,b_,I_,Vd,et,jt,Xi,Qn,y_,Vi,w_,Hd,z,Zn,P_,fe,eo,E_,Hi,F_,$_,xt,j_,kt,to,x_,K,k_,Yi,q_,D_,Ji,T_,C_,Ki,O_,L_,Qi,S_,R_,N_,qt,no,M_,oo,G_,Zi,U_,A_,B_,ue,ao,z_,er,W_,X_,P,V_,tr,H_,Y_,nr,J_,K_,or,Q_,Z_,ar,eh,th,sr,nh,oh,ir,ah,sh,rr,ih,rh,lr,lh,ph,pr,dh,mh,dr,ch,gh,mr,fh,uh,cr,_h,hh,gr,vh,bh,fr,Ih,yh,ur,wh,Ph,_r,Eh,Fh,hr,$h,jh,vr,xh,kh,br,qh,Dh,Ir,Th,Ch,yr,Oh,Lh,wr,Sh,Rh,Yd,tt,Dt,Pr,so,Nh,Er,Mh,Jd,W,io,Gh,_e,ro,Uh,Fr,Ah,Bh,Tt,zh,Ct,lo,Wh,Q,Xh,$r,Vh,Hh,jr,Yh,Jh,xr,Kh,Qh,kr,Zh,ev,tv,Ot,po,nv,mo,ov,qr,av,sv,iv,he,co,rv,Dr,lv,pv,E,dv,Tr,mv,cv,Cr,gv,fv,Or,uv,_v,Lr,hv,vv,Sr,bv,Iv,Rr,yv,wv,Nr,Pv,Ev,Mr,Fv,$v,Gr,jv,xv,Ur,kv,qv,Ar,Dv,Tv,Br,Cv,Ov,zr,Lv,Sv,Wr,Rv,Nv,Xr,Mv,Gv,Vr,Uv,Av,Hr,Bv,zv,Yr,Wv,Xv,Jr,Vv,Hv,Kr,Yv,Jv,Qr,Kv,Qv,Zr,Zv,eb,Kd,nt,Lt,el,go,tb,tl,nb,Qd,X,fo,ob,ve,uo,ab,nl,sb,ib,St,rb,Rt,_o,lb,Z,pb,ol,db,mb,al,cb,gb,sl,fb,ub,il,_b,hb,vb,Nt,ho,bb,vo,Ib,rl,yb,wb,Pb,be,bo,Eb,ll,Fb,$b,F,jb,pl,xb,kb,dl,qb,Db,ml,Tb,Cb,cl,Ob,Lb,gl,Sb,Rb,fl,Nb,Mb,ul,Gb,Ub,_l,Ab,Bb,hl,zb,Wb,vl,Xb,Vb,bl,Hb,Yb,Il,Jb,Kb,yl,Qb,Zb,wl,eI,tI,Pl,nI,oI,El,aI,sI,Fl,iI,rI,$l,lI,pI,jl,dI,mI,xl,cI,gI,kl,fI,uI,ql,_I,hI,Zd,ot,Mt,Dl,Io,vI,Tl,bI,em,V,yo,II,Ie,wo,yI,Cl,wI,PI,Gt,EI,Ut,Po,FI,ee,$I,Ol,jI,xI,Ll,kI,qI,Sl,DI,TI,Rl,CI,OI,LI,At,Eo,SI,Fo,RI,Nl,NI,MI,GI,ye,$o,UI,Ml,AI,BI,$,zI,Gl,WI,XI,Ul,VI,HI,Al,YI,JI,Bl,KI,QI,zl,ZI,e1,Wl,t1,n1,Xl,o1,a1,Vl,s1,i1,Hl,r1,l1,Yl,p1,d1,Jl,m1,c1,Kl,g1,f1,Ql,u1,_1,Zl,h1,v1,ep,b1,I1,tp,y1,w1,np,P1,E1,op,F1,$1,ap,j1,x1,sp,k1,q1,ip,D1,T1,rp,C1,O1,tm,at,Bt,lp,jo,L1,pp,S1,nm,H,xo,R1,we,ko,N1,dp,M1,G1,zt,U1,Wt,qo,A1,te,B1,mp,z1,W1,cp,X1,V1,gp,H1,Y1,fp,J1,K1,Q1,Xt,Do,Z1,To,ey,up,ty,ny,oy,Pe,Co,ay,_p,sy,iy,j,ry,hp,ly,py,vp,dy,my,bp,cy,gy,Ip,fy,uy,yp,_y,hy,wp,vy,by,Pp,Iy,yy,Ep,wy,Py,Fp,Ey,Fy,$p,$y,jy,jp,xy,ky,xp,qy,Dy,kp,Ty,Cy,qp,Oy,Ly,Dp,Sy,Ry,Tp,Ny,My,Cp,Gy,Uy,Op,Ay,By,Lp,zy,Wy,Sp,Xy,Vy,Rp,Hy,Yy,Np,Jy,Ky,om;return g=new U({}),Vt=new U({}),Jt=new U({}),tn=new M({props:{code:"pip install huggingface_hub --upgrade",highlighted:"pip install huggingface_hub --upgrade"}}),nn=new M({props:{code:`from huggingface_hub import login

login()`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> login

login()`}}),an=new M({props:{code:"pip install diffusers accelerate transformers safetensors",highlighted:"pip install diffusers accelerate transformers safetensors"}}),vn=new U({}),In=new M({props:{code:`from diffusers import DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch

# stage 1
stage_1 = DiffusionPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

# stage 2
stage_2 = DiffusionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

# stage 3
safety_modules = {
    "feature_extractor": stage_1.feature_extractor,
    "safety_checker": stage_1.safety_checker,
    "watermarker": stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    "stabilityai/stable-diffusion-x4-upscaler", **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = 'a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says "very deep learning"'
generator = torch.manual_seed(1)

# text embeds
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

# stage 1
image = stage_1(
    prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, generator=generator, output_type="pt"
).images
pt_to_pil(image)[0].save("./if_stage_I.png")

# stage 2
image = stage_2(
    image=image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type="pt",
).images
pt_to_pil(image)[0].save("./if_stage_II.png")

# stage 3
image = stage_3(prompt=prompt, image=image, noise_level=100, generator=generator).images
image[0].save("./if_stage_III.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-keyword">import</span> torch

<span class="hljs-comment"># stage 1</span>
stage_1 = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

<span class="hljs-comment"># stage 2</span>
stage_2 = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

<span class="hljs-comment"># stage 3</span>
safety_modules = {
    <span class="hljs-string">&quot;feature_extractor&quot;</span>: stage_1.feature_extractor,
    <span class="hljs-string">&quot;safety_checker&quot;</span>: stage_1.safety_checker,
    <span class="hljs-string">&quot;watermarker&quot;</span>: stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;stabilityai/stable-diffusion-x4-upscaler&quot;</span>, **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = <span class="hljs-string">&#x27;a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says &quot;very deep learning&quot;&#x27;</span>
generator = torch.manual_seed(<span class="hljs-number">1</span>)

<span class="hljs-comment"># text embeds</span>
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

<span class="hljs-comment"># stage 1</span>
image = stage_1(
    prompt_embeds=prompt_embeds, negative_prompt_embeds=negative_embeds, generator=generator, output_type=<span class="hljs-string">&quot;pt&quot;</span>
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-comment"># stage 2</span>
image = stage_2(
    image=image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)

<span class="hljs-comment"># stage 3</span>
image = stage_3(prompt=prompt, image=image, noise_level=<span class="hljs-number">100</span>, generator=generator).images
image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_III.png&quot;</span>)`}}),yn=new U({}),wn=new M({props:{code:`from diffusers import IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil

import torch

from PIL import Image
import requests
from io import BytesIO

# download image
url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image.resize((768, 512))

# stage 1
stage_1 = IFImg2ImgPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

# stage 2
stage_2 = IFImg2ImgSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

# stage 3
safety_modules = {
    "feature_extractor": stage_1.feature_extractor,
    "safety_checker": stage_1.safety_checker,
    "watermarker": stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    "stabilityai/stable-diffusion-x4-upscaler", **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = "A fantasy landscape in style minecraft"
generator = torch.manual_seed(1)

# text embeds
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

# stage 1
image = stage_1(
    image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type="pt",
).images
pt_to_pil(image)[0].save("./if_stage_I.png")

# stage 2
image = stage_2(
    image=image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type="pt",
).images
pt_to_pil(image)[0].save("./if_stage_II.png")

# stage 3
image = stage_3(prompt=prompt, image=image, generator=generator, noise_level=100).images
image[0].save("./if_stage_III.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil

<span class="hljs-keyword">import</span> torch

<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-comment"># download image</span>
url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>
response = requests.get(url)
original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
original_image = original_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-comment"># stage 1</span>
stage_1 = IFImg2ImgPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

<span class="hljs-comment"># stage 2</span>
stage_2 = IFImg2ImgSuperResolutionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

<span class="hljs-comment"># stage 3</span>
safety_modules = {
    <span class="hljs-string">&quot;feature_extractor&quot;</span>: stage_1.feature_extractor,
    <span class="hljs-string">&quot;safety_checker&quot;</span>: stage_1.safety_checker,
    <span class="hljs-string">&quot;watermarker&quot;</span>: stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;stabilityai/stable-diffusion-x4-upscaler&quot;</span>, **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;A fantasy landscape in style minecraft&quot;</span>
generator = torch.manual_seed(<span class="hljs-number">1</span>)

<span class="hljs-comment"># text embeds</span>
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

<span class="hljs-comment"># stage 1</span>
image = stage_1(
    image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-comment"># stage 2</span>
image = stage_2(
    image=image,
    original_image=original_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)

<span class="hljs-comment"># stage 3</span>
image = stage_3(prompt=prompt, image=image, generator=generator, noise_level=<span class="hljs-number">100</span>).images
image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_III.png&quot;</span>)`}}),Pn=new U({}),En=new M({props:{code:`from diffusers import IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
from diffusers.utils import pt_to_pil
import torch

from PIL import Image
import requests
from io import BytesIO

# download image
url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png"
response = requests.get(url)
original_image = Image.open(BytesIO(response.content)).convert("RGB")
original_image = original_image

# download mask
url = "https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png"
response = requests.get(url)
mask_image = Image.open(BytesIO(response.content))
mask_image = mask_image

# stage 1
stage_1 = IFInpaintingPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

# stage 2
stage_2 = IFInpaintingSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

# stage 3
safety_modules = {
    "feature_extractor": stage_1.feature_extractor,
    "safety_checker": stage_1.safety_checker,
    "watermarker": stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    "stabilityai/stable-diffusion-x4-upscaler", **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = "blue sunglasses"
generator = torch.manual_seed(1)

# text embeds
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

# stage 1
image = stage_1(
    image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type="pt",
).images
pt_to_pil(image)[0].save("./if_stage_I.png")

# stage 2
image = stage_2(
    image=image,
    original_image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type="pt",
).images
pt_to_pil(image)[0].save("./if_stage_II.png")

# stage 3
image = stage_3(prompt=prompt, image=image, generator=generator, noise_level=100).images
image[0].save("./if_stage_III.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline, DiffusionPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil
<span class="hljs-keyword">import</span> torch

<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-comment"># download image</span>
url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/person.png&quot;</span>
response = requests.get(url)
original_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
original_image = original_image

<span class="hljs-comment"># download mask</span>
url = <span class="hljs-string">&quot;https://huggingface.co/datasets/diffusers/docs-images/resolve/main/if/glasses_mask.png&quot;</span>
response = requests.get(url)
mask_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content))
mask_image = mask_image

<span class="hljs-comment"># stage 1</span>
stage_1 = IFInpaintingPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
stage_1.enable_model_cpu_offload()

<span class="hljs-comment"># stage 2</span>
stage_2 = IFInpaintingSuperResolutionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16
)
stage_2.enable_model_cpu_offload()

<span class="hljs-comment"># stage 3</span>
safety_modules = {
    <span class="hljs-string">&quot;feature_extractor&quot;</span>: stage_1.feature_extractor,
    <span class="hljs-string">&quot;safety_checker&quot;</span>: stage_1.safety_checker,
    <span class="hljs-string">&quot;watermarker&quot;</span>: stage_1.watermarker,
}
stage_3 = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;stabilityai/stable-diffusion-x4-upscaler&quot;</span>, **safety_modules, torch_dtype=torch.float16
)
stage_3.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;blue sunglasses&quot;</span>
generator = torch.manual_seed(<span class="hljs-number">1</span>)

<span class="hljs-comment"># text embeds</span>
prompt_embeds, negative_embeds = stage_1.encode_prompt(prompt)

<span class="hljs-comment"># stage 1</span>
image = stage_1(
    image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-comment"># stage 2</span>
image = stage_2(
    image=image,
    original_image=original_image,
    mask_image=mask_image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    generator=generator,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
).images
pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)

<span class="hljs-comment"># stage 3</span>
image = stage_3(prompt=prompt, image=image, generator=generator, noise_level=<span class="hljs-number">100</span>).images
image[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_III.png&quot;</span>)`}}),Fn=new U({}),$n=new M({props:{code:`from diffusers import IFPipeline, IFSuperResolutionPipeline

pipe_1 = IFPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0")
pipe_2 = IFSuperResolutionPipeline.from_pretrained("DeepFloyd/IF-II-L-v1.0")


from diffusers import IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline

pipe_1 = IFImg2ImgPipeline(**pipe_1.components)
pipe_2 = IFImg2ImgSuperResolutionPipeline(**pipe_2.components)


from diffusers import IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline

pipe_1 = IFInpaintingPipeline(**pipe_1.components)
pipe_2 = IFInpaintingSuperResolutionPipeline(**pipe_2.components)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFPipeline, IFSuperResolutionPipeline

pipe_1 = IFPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>)
pipe_2 = IFSuperResolutionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>)


<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFImg2ImgPipeline, IFImg2ImgSuperResolutionPipeline

pipe_1 = IFImg2ImgPipeline(**pipe_1.components)
pipe_2 = IFImg2ImgSuperResolutionPipeline(**pipe_2.components)


<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFInpaintingPipeline, IFInpaintingSuperResolutionPipeline

pipe_1 = IFInpaintingPipeline(**pipe_1.components)
pipe_2 = IFInpaintingSuperResolutionPipeline(**pipe_2.components)`}}),jn=new U({}),xn=new M({props:{code:`pipe = DiffusionPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.to("cuda")`,highlighted:`pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)`}}),kn=new M({props:{code:'pipe("<prompt>", num_inference_steps=30)',highlighted:'pipe(<span class="hljs-string">&quot;&lt;prompt&gt;&quot;</span>, num_inference_steps=<span class="hljs-number">30</span>)'}}),qn=new M({props:{code:`from diffusers.pipelines.deepfloyd_if import fast27_timesteps

pipe("<prompt>", timesteps=fast27_timesteps)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.pipelines.deepfloyd_if <span class="hljs-keyword">import</span> fast27_timesteps

pipe(<span class="hljs-string">&quot;&lt;prompt&gt;&quot;</span>, timesteps=fast27_timesteps)`}}),Dn=new M({props:{code:`pipe = IFImg2ImgPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.to("cuda")

image = pipe(image=image, prompt="<prompt>", strength=0.3).images`,highlighted:`pipe = IFImg2ImgPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

image = pipe(image=image, prompt=<span class="hljs-string">&quot;&lt;prompt&gt;&quot;</span>, strength=<span class="hljs-number">0.3</span>).images`}}),Tn=new M({props:{code:`import torch

pipe = DiffusionPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.to("cuda")

pipe.text_encoder = torch.compile(pipe.text_encoder)
pipe.unet = torch.compile(pipe.unet)`,highlighted:`<span class="hljs-keyword">import</span> torch

pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.text_encoder = torch.<span class="hljs-built_in">compile</span>(pipe.text_encoder)
pipe.unet = torch.<span class="hljs-built_in">compile</span>(pipe.unet)`}}),Cn=new U({}),On=new M({props:{code:`pipe = DiffusionPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.enable_model_cpu_offload()`,highlighted:`pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipe.enable_model_cpu_offload()`}}),Ln=new M({props:{code:`pipe = DiffusionPipeline.from_pretrained("DeepFloyd/IF-I-XL-v1.0", variant="fp16", torch_dtype=torch.float16)
pipe.enable_sequential_cpu_offload()`,highlighted:`pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipe.enable_sequential_cpu_offload()`}}),Sn=new M({props:{code:`from transformers import T5EncoderModel

text_encoder = T5EncoderModel.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0", subfolder="text_encoder", device_map="auto", load_in_8bit=True, variant="8bit"
)

from diffusers import DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0",
    text_encoder=text_encoder,  # pass the previously instantiated 8bit text encoder
    unet=None,
    device_map="auto",
)

prompt_embeds, negative_embeds = pipe.encode_prompt("<prompt>")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5EncoderModel

text_encoder = T5EncoderModel.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, subfolder=<span class="hljs-string">&quot;text_encoder&quot;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, load_in_8bit=<span class="hljs-literal">True</span>, variant=<span class="hljs-string">&quot;8bit&quot;</span>
)

<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>,
    text_encoder=text_encoder,  <span class="hljs-comment"># pass the previously instantiated 8bit text encoder</span>
    unet=<span class="hljs-literal">None</span>,
    device_map=<span class="hljs-string">&quot;auto&quot;</span>,
)

prompt_embeds, negative_embeds = pipe.encode_prompt(<span class="hljs-string">&quot;&lt;prompt&gt;&quot;</span>)`}}),Rn=new M({props:{code:`from diffusers import IFPipeline, IFSuperResolutionPipeline
import torch
import gc
from transformers import T5EncoderModel
from diffusers.utils import pt_to_pil

text_encoder = T5EncoderModel.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0", subfolder="text_encoder", device_map="auto", load_in_8bit=True, variant="8bit"
)

# text to image

pipe = DiffusionPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0",
    text_encoder=text_encoder,  # pass the previously instantiated 8bit text encoder
    unet=None,
    device_map="auto",
)

prompt = 'a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says "very deep learning"'
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

# Remove the pipeline so we can re-load the pipeline with the unet
del text_encoder
del pipe
gc.collect()
torch.cuda.empty_cache()

pipe = IFPipeline.from_pretrained(
    "DeepFloyd/IF-I-XL-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16, device_map="auto"
)

generator = torch.Generator().manual_seed(0)
image = pipe(
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
    generator=generator,
).images

pt_to_pil(image)[0].save("./if_stage_I.png")

# Remove the pipeline so we can load the super-resolution pipeline
del pipe
gc.collect()
torch.cuda.empty_cache()

# First super resolution

pipe = IFSuperResolutionPipeline.from_pretrained(
    "DeepFloyd/IF-II-L-v1.0", text_encoder=None, variant="fp16", torch_dtype=torch.float16, device_map="auto"
)

generator = torch.Generator().manual_seed(0)
image = pipe(
    image=image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type="pt",
    generator=generator,
).images

pt_to_pil(image)[0].save("./if_stage_II.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> IFPipeline, IFSuperResolutionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">import</span> gc
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> T5EncoderModel
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> pt_to_pil

text_encoder = T5EncoderModel.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, subfolder=<span class="hljs-string">&quot;text_encoder&quot;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, load_in_8bit=<span class="hljs-literal">True</span>, variant=<span class="hljs-string">&quot;8bit&quot;</span>
)

<span class="hljs-comment"># text to image</span>

pipe = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>,
    text_encoder=text_encoder,  <span class="hljs-comment"># pass the previously instantiated 8bit text encoder</span>
    unet=<span class="hljs-literal">None</span>,
    device_map=<span class="hljs-string">&quot;auto&quot;</span>,
)

prompt = <span class="hljs-string">&#x27;a photo of a kangaroo wearing an orange hoodie and blue sunglasses standing in front of the eiffel tower holding a sign that says &quot;very deep learning&quot;&#x27;</span>
prompt_embeds, negative_embeds = pipe.encode_prompt(prompt)

<span class="hljs-comment"># Remove the pipeline so we can re-load the pipeline with the unet</span>
<span class="hljs-keyword">del</span> text_encoder
<span class="hljs-keyword">del</span> pipe
gc.collect()
torch.cuda.empty_cache()

pipe = IFPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-I-XL-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16, device_map=<span class="hljs-string">&quot;auto&quot;</span>
)

generator = torch.Generator().manual_seed(<span class="hljs-number">0</span>)
image = pipe(
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
    generator=generator,
).images

pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_I.png&quot;</span>)

<span class="hljs-comment"># Remove the pipeline so we can load the super-resolution pipeline</span>
<span class="hljs-keyword">del</span> pipe
gc.collect()
torch.cuda.empty_cache()

<span class="hljs-comment"># First super resolution</span>

pipe = IFSuperResolutionPipeline.from_pretrained(
    <span class="hljs-string">&quot;DeepFloyd/IF-II-L-v1.0&quot;</span>, text_encoder=<span class="hljs-literal">None</span>, variant=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16, device_map=<span class="hljs-string">&quot;auto&quot;</span>
)

generator = torch.Generator().manual_seed(<span class="hljs-number">0</span>)
image = pipe(
    image=image,
    prompt_embeds=prompt_embeds,
    negative_prompt_embeds=negative_embeds,
    output_type=<span class="hljs-string">&quot;pt&quot;</span>,
    generator=generator,
).images

pt_to_pil(image)[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;./if_stage_II.png&quot;</span>)`}}),Nn=new U({}),Wn=new U({}),Xn=new R({props:{name:"class diffusers.IFPipeline",anchor:"diffusers.IFPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py#L89"}}),Vn=new R({props:{name:"__call__",anchor:"diffusers.IFPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"num_inference_steps",val:": int = 100"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 7.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"clean_caption",val:": bool = True"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.IFPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.IFPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.IFPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"},{anchor:"diffusers.IFPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py#L625",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),Et=new Xa({props:{anchor:"diffusers.IFPipeline.__call__.example",$$slots:{default:[p$]},$$scope:{ctx:Y}}}),Hn=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py#L171"}}),Yn=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py#L147"}}),Kn=new R({props:{name:"encode_prompt",anchor:"diffusers.IFPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py#L245"}}),Qn=new U({}),Zn=new R({props:{name:"class diffusers.IFSuperResolutionPipeline",anchor:"diffusers.IFSuperResolutionPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"image_noising_scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_superresolution.py#L73"}}),eo=new R({props:{name:"__call__",anchor:"diffusers.IFSuperResolutionPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[PIL.Image.Image, numpy.ndarray, torch.FloatTensor] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 4.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"noise_level",val:": int = 250"},{name:"clean_caption",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.IFSuperResolutionPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>, <code>np.ndarray</code>, <code>torch.FloatTensor</code>) &#x2014;
The image to be upscaled.`,name:"image"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.noise_level",description:`<strong>noise_level</strong> (<code>int</code>, <em>optional</em>, defaults to 250) &#x2014;
The amount of noise to add to the upscaled image. Must be in the range <code>[0, 1000)</code>`,name:"noise_level"},{anchor:"diffusers.IFSuperResolutionPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_superresolution.py#L693",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),xt=new Xa({props:{anchor:"diffusers.IFSuperResolutionPipeline.__call__.example",$$slots:{default:[d$]},$$scope:{ctx:Y}}}),to=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFSuperResolutionPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_superresolution.py#L165"}}),no=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFSuperResolutionPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_superresolution.py#L140"}}),ao=new R({props:{name:"encode_prompt",anchor:"diffusers.IFSuperResolutionPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFSuperResolutionPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_superresolution.py#L380"}}),so=new U({}),io=new R({props:{name:"class diffusers.IFImg2ImgPipeline",anchor:"diffusers.IFImg2ImgPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py#L113"}}),ro=new R({props:{name:"__call__",anchor:"diffusers.IFImg2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"strength",val:": float = 0.7"},{name:"num_inference_steps",val:": int = 80"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 10.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"clean_caption",val:": bool = True"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.IFImg2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"},{anchor:"diffusers.IFImg2ImgPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py#L740",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),Tt=new Xa({props:{anchor:"diffusers.IFImg2ImgPipeline.__call__.example",$$slots:{default:[m$]},$$scope:{ctx:Y}}}),lo=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFImg2ImgPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py#L197"}}),po=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFImg2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py#L172"}}),co=new R({props:{name:"encode_prompt",anchor:"diffusers.IFImg2ImgPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFImg2ImgPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py#L272"}}),go=new U({}),fo=new R({props:{name:"class diffusers.IFImg2ImgSuperResolutionPipeline",anchor:"diffusers.IFImg2ImgSuperResolutionPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"image_noising_scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py#L115"}}),uo=new R({props:{name:"__call__",anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__",parameters:[{name:"image",val:": typing.Union[PIL.Image.Image, numpy.ndarray, torch.FloatTensor]"},{name:"original_image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"strength",val:": float = 0.8"},{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 4.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"noise_level",val:": int = 250"},{name:"clean_caption",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.original_image",description:`<strong>original_image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
The original image that <code>image</code> was varied from.`,name:"original_image"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.noise_level",description:`<strong>noise_level</strong> (<code>int</code>, <em>optional</em>, defaults to 250) &#x2014;
The amount of noise to add to the upscaled image. Must be in the range <code>[0, 1000)</code>`,name:"noise_level"},{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py#L821",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),St=new Xa({props:{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.__call__.example",$$slots:{default:[c$]},$$scope:{ctx:Y}}}),_o=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py#L207"}}),ho=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py#L182"}}),bo=new R({props:{name:"encode_prompt",anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFImg2ImgSuperResolutionPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py#L422"}}),Io=new U({}),yo=new R({props:{name:"class diffusers.IFInpaintingPipeline",anchor:"diffusers.IFInpaintingPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py#L116"}}),wo=new R({props:{name:"__call__",anchor:"diffusers.IFInpaintingPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"mask_image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"strength",val:": float = 1.0"},{name:"num_inference_steps",val:": int = 50"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 7.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"clean_caption",val:": bool = True"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.IFInpaintingPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFInpaintingPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.IFInpaintingPipeline.__call__.mask_image",description:`<strong>mask_image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, to mask <code>image</code>. White pixels in the mask will be
repainted, while black pixels will be preserved. If <code>mask_image</code> is a PIL image, it will be converted
to a single channel (luminance) before use. If it&#x2019;s a tensor, it should contain one color channel (L)
instead of 3, so the expected shape would be <code>(B, H, W, 1)</code>.`,name:"mask_image"},{anchor:"diffusers.IFInpaintingPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.IFInpaintingPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFInpaintingPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFInpaintingPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFInpaintingPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFInpaintingPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFInpaintingPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFInpaintingPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFInpaintingPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFInpaintingPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFInpaintingPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFInpaintingPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFInpaintingPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFInpaintingPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFInpaintingPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"},{anchor:"diffusers.IFInpaintingPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py#L832",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),Gt=new Xa({props:{anchor:"diffusers.IFInpaintingPipeline.__call__.example",$$slots:{default:[g$]},$$scope:{ctx:Y}}}),Po=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFInpaintingPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py#L200"}}),Eo=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFInpaintingPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py#L175"}}),$o=new R({props:{name:"encode_prompt",anchor:"diffusers.IFInpaintingPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFInpaintingPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py#L275"}}),jo=new U({}),xo=new R({props:{name:"class diffusers.IFInpaintingSuperResolutionPipeline",anchor:"diffusers.IFInpaintingSuperResolutionPipeline",parameters:[{name:"tokenizer",val:": T5Tokenizer"},{name:"text_encoder",val:": T5EncoderModel"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": DDPMScheduler"},{name:"image_noising_scheduler",val:": DDPMScheduler"},{name:"safety_checker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.safety_checker.IFSafetyChecker]"},{name:"feature_extractor",val:": typing.Optional[transformers.models.clip.image_processing_clip.CLIPImageProcessor]"},{name:"watermarker",val:": typing.Optional[diffusers.pipelines.deepfloyd_if.watermark.IFWatermarker]"},{name:"requires_safety_checker",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py#L117"}}),ko=new R({props:{name:"__call__",anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__",parameters:[{name:"image",val:": typing.Union[PIL.Image.Image, numpy.ndarray, torch.FloatTensor]"},{name:"original_image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"mask_image",val:": typing.Union[PIL.Image.Image, torch.Tensor, numpy.ndarray, typing.List[PIL.Image.Image], typing.List[torch.Tensor], typing.List[numpy.ndarray]] = None"},{name:"strength",val:": float = 0.8"},{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"num_inference_steps",val:": int = 100"},{name:"timesteps",val:": typing.List[int] = None"},{name:"guidance_scale",val:": float = 4.0"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"noise_level",val:": int = 0"},{name:"clean_caption",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.original_image",description:`<strong>original_image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
The original image that <code>image</code> was varied from.`,name:"original_image"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.mask_image",description:`<strong>mask_image</strong> (<code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, to mask <code>image</code>. White pixels in the mask will be
repainted, while black pixels will be preserved. If <code>mask_image</code> is a PIL image, it will be converted
to a single channel (luminance) before use. If it&#x2019;s a tensor, it should contain one color channel (L)
instead of 3, so the expected shape would be <code>(B, H, W, 1)</code>.`,name:"mask_image"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps to use for the denoising process. If not defined, equal spaced <code>num_inference_steps</code>
timesteps are used. Must be in descending order.`,name:"timesteps"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_187/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>~pipelines.stable_diffusion.IFPipelineOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.noise_level",description:`<strong>noise_level</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The amount of noise to add to the upscaled image. Must be in the range <code>[0, 1000)</code>`,name:"noise_level"},{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.clean_caption",description:`<strong>clean_caption</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to clean the caption before creating embeddings. Requires <code>beautifulsoup4</code> and <code>ftfy</code> to
be installed. If the dependencies are not installed, the embeddings will be created from the raw
prompt.`,name:"clean_caption"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py#L909",returnDescription:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) or watermarked content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>~pipelines.stable_diffusion.IFPipelineOutput</code> or <code>tuple</code></p>
`}}),zt=new Xa({props:{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.__call__.example",$$slots:{default:[f$]},$$scope:{ctx:Y}}}),qo=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.IFInpaintingSuperResolutionPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py#L209"}}),Do=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.IFInpaintingSuperResolutionPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py#L184"}}),Co=new R({props:{name:"encode_prompt",anchor:"diffusers.IFInpaintingSuperResolutionPipeline.encode_prompt",parameters:[{name:"prompt",val:""},{name:"do_classifier_free_guidance",val:" = True"},{name:"num_images_per_prompt",val:" = 1"},{name:"device",val:" = None"},{name:"negative_prompt",val:" = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"clean_caption",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.IFInpaintingSuperResolutionPipeline.encode_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
prompt to be encoded`,name:"prompt"}],source:"https://github.com/huggingface/diffusers/blob/vr_187/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py#L424"}}),{c(){y=s("meta"),N=l(),L=s("h1"),I=s("a"),S=s("span"),f(g.$$.fragment),O=l(),Ha=s("span"),Qm=o("IF"),Bp=l(),Se=s("h2"),st=s("a"),Ya=s("span"),f(Vt.$$.fragment),Zm=l(),Ja=s("span"),ec=o("Overview"),zp=l(),No=s("p"),tc=o(`DeepFloyd IF is a novel state-of-the-art open-source text-to-image model with a high degree of photorealism and language understanding.
The model is a modular composed of a frozen text encoder and three cascaded pixel diffusion modules:`),Wp=l(),ie=s("ul"),Ka=s("li"),nc=o("Stage 1: a base model that generates 64x64 px image based on text prompt,"),oc=l(),Qa=s("li"),ac=o("Stage 2: a 64x64 px => 256x256 px super-resolution model, and a"),sc=l(),Ht=s("li"),ic=o(`Stage 3: a 256x256 px => 1024x1024 px super-resolution model
Stage 1 and Stage 2 utilize a frozen text encoder based on the T5 transformer to extract text embeddings,
which are then fed into a UNet architecture enhanced with cross-attention and attention pooling.
Stage 3 is `),Yt=s("a"),rc=o("Stability\u2019s x4 Upscaling model"),lc=o(`.
The result is a highly efficient model that outperforms current state-of-the-art models, achieving a zero-shot FID score of 6.66 on the COCO dataset.
Our work underscores the potential of larger UNet architectures in the first stage of cascaded diffusion models and depicts a promising future for text-to-image synthesis.`),Xp=l(),Re=s("h2"),it=s("a"),Za=s("span"),f(Jt.$$.fragment),pc=l(),es=s("span"),dc=o("Usage"),Vp=l(),Mo=s("p"),mc=o("Before you can use IF, you need to accept its usage conditions. To do so:"),Hp=l(),re=s("ol"),Kt=s("li"),cc=o("Make sure to have a "),Qt=s("a"),gc=o("Hugging Face account"),fc=o(" and be logged in"),uc=l(),Zt=s("li"),_c=o("Accept the license on the model card of "),en=s("a"),hc=o("DeepFloyd/IF-I-XL-v1.0"),vc=o(". Accepting the license on the stage I model card will auto accept for the other IF models."),bc=l(),Go=s("li"),Ic=o("Make sure to login locally. Install "),ts=s("code"),yc=o("huggingface_hub"),Yp=l(),f(tn.$$.fragment),Jp=l(),Uo=s("p"),wc=o("run the login function in a Python shell"),Kp=l(),f(nn.$$.fragment),Qp=l(),rt=s("p"),Pc=o("and enter your "),on=s("a"),Ec=o("Hugging Face Hub access token"),Fc=o("."),Zp=l(),lt=s("p"),$c=o("Next we install "),ns=s("code"),jc=o("diffusers"),xc=o(" and dependencies:"),ed=l(),f(an.$$.fragment),td=l(),Ao=s("p"),kc=o("The following sections give more in-detail examples of how to use IF. Specifically:"),nd=l(),G=s("ul"),os=s("li"),Bo=s("a"),qc=o("Text-to-Image Generation"),Dc=l(),as=s("li"),zo=s("a"),Tc=o("Image-to-Image Generation"),Cc=l(),ss=s("li"),Wo=s("a"),Oc=o("Inpainting"),Lc=l(),is=s("li"),Xo=s("a"),Sc=o("Reusing model weights"),Rc=l(),rs=s("li"),Vo=s("a"),Nc=o("Speed optimization"),Mc=l(),ls=s("li"),Ho=s("a"),Gc=o("Memory optimization"),od=l(),Yo=s("p"),ps=s("strong"),Uc=o("Available checkpoints"),ad=l(),le=s("ul"),sn=s("li"),ds=s("p"),ms=s("em"),Ac=o("Stage-1"),Bc=l(),Ne=s("ul"),cs=s("li"),rn=s("a"),zc=o("DeepFloyd/IF-I-XL-v1.0"),Wc=l(),gs=s("li"),ln=s("a"),Xc=o("DeepFloyd/IF-I-L-v1.0"),Vc=l(),fs=s("li"),pn=s("a"),Hc=o("DeepFloyd/IF-I-M-v1.0"),Yc=l(),dn=s("li"),us=s("p"),_s=s("em"),Jc=o("Stage-2"),Kc=l(),mn=s("ul"),hs=s("li"),cn=s("a"),Qc=o("DeepFloyd/IF-II-L-v1.0"),Zc=l(),vs=s("li"),gn=s("a"),eg=o("DeepFloyd/IF-II-M-v1.0"),tg=l(),fn=s("li"),bs=s("p"),Is=s("em"),ng=o("Stage-3"),og=l(),ys=s("ul"),ws=s("li"),un=s("a"),ag=o("stabilityai/stable-diffusion-x4-upscaler"),sd=l(),pt=s("p"),Ps=s("strong"),sg=o("Demo"),ig=l(),_n=s("a"),Jo=s("img"),id=l(),dt=s("p"),Es=s("strong"),rg=o("Google Colab"),lg=l(),hn=s("a"),Ko=s("img"),rd=l(),Me=s("h3"),mt=s("a"),Fs=s("span"),f(vn.$$.fragment),pg=l(),$s=s("span"),dg=o("Text-to-Image Generation"),ld=l(),ct=s("p"),mg=o("By default diffusers makes use of "),bn=s("a"),cg=o("model cpu offloading"),gg=o(`
to run the whole IF pipeline with as little as 14 GB of VRAM.`),pd=l(),f(In.$$.fragment),dd=l(),Ge=s("h3"),gt=s("a"),js=s("span"),f(yn.$$.fragment),fg=l(),xs=s("span"),ug=o("Text Guided Image-to-Image Generation"),md=l(),pe=s("p"),_g=o(`The same IF model weights can be used for text-guided image-to-image translation or image variation.
In this case just make sure to load the weights using the `),Qo=s("a"),hg=o("IFInpaintingPipeline"),vg=o(" and "),Zo=s("a"),bg=o("IFInpaintingSuperResolutionPipeline"),Ig=o(" pipelines."),cd=l(),ae=s("p"),ks=s("strong"),yg=o("Note"),wg=o(`: You can also directly move the weights of the text-to-image pipelines to the image-to-image pipelines
without loading them twice by making use of the `),qs=s("code"),Pg=o("~DiffusionPipeline.components()"),Eg=o(" function as explained "),ea=s("a"),Fg=o("here"),$g=o("."),gd=l(),f(wn.$$.fragment),fd=l(),Ue=s("h3"),ft=s("a"),Ds=s("span"),f(Pn.$$.fragment),jg=l(),Ts=s("span"),xg=o("Text Guided Inpainting Generation"),ud=l(),de=s("p"),kg=o(`The same IF model weights can be used for text-guided image-to-image translation or image variation.
In this case just make sure to load the weights using the `),ta=s("a"),qg=o("IFInpaintingPipeline"),Dg=o(" and "),na=s("a"),Tg=o("IFInpaintingSuperResolutionPipeline"),Cg=o(" pipelines."),_d=l(),se=s("p"),Cs=s("strong"),Og=o("Note"),Lg=o(`: You can also directly move the weights of the text-to-image pipelines to the image-to-image pipelines
without loading them twice by making use of the `),Os=s("code"),Sg=o("~DiffusionPipeline.components()"),Rg=o(" function as explained "),oa=s("a"),Ng=o("here"),Mg=o("."),hd=l(),f(En.$$.fragment),vd=l(),Ae=s("h3"),ut=s("a"),Ls=s("span"),f(Fn.$$.fragment),Gg=l(),Ss=s("span"),Ug=o("Converting between different pipelines"),bd=l(),_t=s("p"),Ag=o("In addition to being loaded with "),Rs=s("code"),Bg=o("from_pretrained"),zg=o(", Pipelines can also be loaded directly from each other."),Id=l(),f($n.$$.fragment),yd=l(),Be=s("h3"),ht=s("a"),Ns=s("span"),f(jn.$$.fragment),Wg=l(),Ms=s("span"),Xg=o("Optimizing for speed"),wd=l(),aa=s("p"),Vg=o("The simplest optimization to run IF faster is to move all model components to the GPU."),Pd=l(),f(xn.$$.fragment),Ed=l(),sa=s("p"),Hg=o("You can also run the diffusion process for a shorter number of timesteps."),Fd=l(),vt=s("p"),Yg=o("This can either be done with the "),Gs=s("code"),Jg=o("num_inference_steps"),Kg=o(" argument"),$d=l(),f(kn.$$.fragment),jd=l(),bt=s("p"),Qg=o("Or with the "),Us=s("code"),Zg=o("timesteps"),ef=o(" argument"),xd=l(),f(qn.$$.fragment),kd=l(),ia=s("p"),tf=o(`When doing image variation or inpainting, you can also decrease the number of timesteps
with the strength argument. The strength argument is the amount of noise to add to
the input image which also determines how many steps to run in the denoising process.
A smaller number will vary the image less but run faster.`),qd=l(),f(Dn.$$.fragment),Dd=l(),me=s("p"),nf=o("You can also use "),ra=s("a"),As=s("code"),of=o("torch.compile"),af=o(". Note that we have not exhaustively tested "),Bs=s("code"),sf=o("torch.compile"),rf=o(`
with IF and it might not give expected results.`),Td=l(),f(Tn.$$.fragment),Cd=l(),ze=s("h3"),It=s("a"),zs=s("span"),f(Cn.$$.fragment),lf=l(),Ws=s("span"),pf=o("Optimizing for memory"),Od=l(),la=s("p"),df=o("When optimizing for GPU memory, we can use the standard diffusers cpu offloading APIs."),Ld=l(),pa=s("p"),mf=o("Either the model based CPU offloading,"),Sd=l(),f(On.$$.fragment),Rd=l(),da=s("p"),cf=o("or the more aggressive layer based CPU offloading."),Nd=l(),f(Ln.$$.fragment),Md=l(),ma=s("p"),gf=o("Additionally, T5 can be loaded in 8bit precision"),Gd=l(),f(Sn.$$.fragment),Ud=l(),ca=s("p"),ff=o(`For CPU RAM constrained machines like google colab free tier where we can\u2019t load all
model components to the CPU at once, we can manually only load the pipeline with
the text encoder or unet when the respective model components are needed.`),Ad=l(),f(Rn.$$.fragment),Bd=l(),We=s("h2"),yt=s("a"),Xs=s("span"),f(Nn.$$.fragment),uf=l(),Vs=s("span"),_f=o("Available Pipelines:"),zd=l(),wt=s("table"),Hs=s("thead"),Xe=s("tr"),Ys=s("th"),hf=o("Pipeline"),vf=l(),Js=s("th"),bf=o("Tasks"),If=l(),ga=s("th"),yf=o("Colab"),wf=l(),A=s("tbody"),Ve=s("tr"),Ks=s("td"),Mn=s("a"),Pf=o("pipeline_if.py"),Ef=l(),Qs=s("td"),Zs=s("em"),Ff=o("Text-to-Image Generation"),$f=l(),fa=s("td"),jf=o("-"),xf=l(),He=s("tr"),ei=s("td"),Gn=s("a"),kf=o("pipeline_if_superresolution.py"),qf=l(),ti=s("td"),ni=s("em"),Df=o("Text-to-Image Generation"),Tf=l(),ua=s("td"),Cf=o("-"),Of=l(),Ye=s("tr"),oi=s("td"),Un=s("a"),Lf=o("pipeline_if_img2img.py"),Sf=l(),ai=s("td"),si=s("em"),Rf=o("Image-to-Image Generation"),Nf=l(),_a=s("td"),Mf=o("-"),Gf=l(),Je=s("tr"),ii=s("td"),An=s("a"),Uf=o("pipeline_if_img2img_superresolution.py"),Af=l(),ri=s("td"),li=s("em"),Bf=o("Image-to-Image Generation"),zf=l(),ha=s("td"),Wf=o("-"),Xf=l(),Ke=s("tr"),pi=s("td"),Bn=s("a"),Vf=o("pipeline_if_inpainting.py"),Hf=l(),di=s("td"),mi=s("em"),Yf=o("Image-to-Image Generation"),Jf=l(),va=s("td"),Kf=o("-"),Qf=l(),Qe=s("tr"),ci=s("td"),zn=s("a"),Zf=o("pipeline_if_inpainting_superresolution.py"),eu=l(),gi=s("td"),fi=s("em"),tu=o("Image-to-Image Generation"),nu=l(),ba=s("td"),ou=o("-"),Wd=l(),Ze=s("h2"),Pt=s("a"),ui=s("span"),f(Wn.$$.fragment),au=l(),_i=s("span"),su=o("IFPipeline"),Xd=l(),B=s("div"),f(Xn.$$.fragment),iu=l(),ce=s("div"),f(Vn.$$.fragment),ru=l(),hi=s("p"),lu=o("Function invoked when calling the pipeline for generation."),pu=l(),f(Et.$$.fragment),du=l(),Ft=s("div"),f(Hn.$$.fragment),mu=l(),J=s("p"),cu=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),vi=s("code"),gu=o("enable_sequential_cpu_offload"),fu=o(", this method moves one whole model at a time to the GPU when its "),bi=s("code"),uu=o("forward"),_u=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ii=s("code"),hu=o("enable_sequential_cpu_offload"),vu=o(", but performance is much better due to the iterative execution of the "),yi=s("code"),bu=o("unet"),Iu=o("."),yu=l(),$t=s("div"),f(Yn.$$.fragment),wu=l(),Jn=s("p"),Pu=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),wi=s("code"),Eu=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Fu=o("forward` method called."),$u=l(),ge=s("div"),f(Kn.$$.fragment),ju=l(),Pi=s("p"),xu=o("Encodes the prompt into text encoder hidden states."),ku=l(),w=s("p"),qu=o("device: ("),Ei=s("code"),Du=o("torch.device"),Tu=o(", "),Fi=s("em"),Cu=o("optional"),Ou=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),$i=s("code"),Lu=o("int"),Su=o(", "),ji=s("em"),Ru=o("optional"),Nu=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),xi=s("code"),Mu=o("bool"),Gu=o(", "),ki=s("em"),Uu=o("optional"),Au=o(", defaults to "),qi=s("code"),Bu=o("True"),zu=o(`):
whether to use classifier free guidance or not
negative_prompt (`),Di=s("code"),Wu=o("str"),Xu=o(" or "),Ti=s("code"),Vu=o("List[str]"),Hu=o(", "),Ci=s("em"),Yu=o("optional"),Ju=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Oi=s("code"),Ku=o("negative_prompt_embeds"),Qu=o(". instead. If not defined, one has to pass "),Li=s("code"),Zu=o("negative_prompt_embeds"),e_=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),Si=s("code"),t_=o("guidance_scale"),n_=o(" is less than "),Ri=s("code"),o_=o("1"),a_=o(`).
prompt_embeds (`),Ni=s("code"),s_=o("torch.FloatTensor"),i_=o(", "),Mi=s("em"),r_=o("optional"),l_=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Gi=s("em"),p_=o("e.g."),d_=o(` prompt weighting. If not
provided, text embeddings will be generated from `),Ui=s("code"),m_=o("prompt"),c_=o(` input argument.
negative_prompt_embeds (`),Ai=s("code"),g_=o("torch.FloatTensor"),f_=o(", "),Bi=s("em"),u_=o("optional"),__=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),zi=s("em"),h_=o("e.g."),v_=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Wi=s("code"),b_=o("negative_prompt"),I_=o(` input
argument.`),Vd=l(),et=s("h2"),jt=s("a"),Xi=s("span"),f(Qn.$$.fragment),y_=l(),Vi=s("span"),w_=o("IFSuperResolutionPipeline"),Hd=l(),z=s("div"),f(Zn.$$.fragment),P_=l(),fe=s("div"),f(eo.$$.fragment),E_=l(),Hi=s("p"),F_=o("Function invoked when calling the pipeline for generation."),$_=l(),f(xt.$$.fragment),j_=l(),kt=s("div"),f(to.$$.fragment),x_=l(),K=s("p"),k_=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Yi=s("code"),q_=o("enable_sequential_cpu_offload"),D_=o(", this method moves one whole model at a time to the GPU when its "),Ji=s("code"),T_=o("forward"),C_=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ki=s("code"),O_=o("enable_sequential_cpu_offload"),L_=o(", but performance is much better due to the iterative execution of the "),Qi=s("code"),S_=o("unet"),R_=o("."),N_=l(),qt=s("div"),f(no.$$.fragment),M_=l(),oo=s("p"),G_=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),Zi=s("code"),U_=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),A_=o("forward` method called."),B_=l(),ue=s("div"),f(ao.$$.fragment),z_=l(),er=s("p"),W_=o("Encodes the prompt into text encoder hidden states."),X_=l(),P=s("p"),V_=o("device: ("),tr=s("code"),H_=o("torch.device"),Y_=o(", "),nr=s("em"),J_=o("optional"),K_=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),or=s("code"),Q_=o("int"),Z_=o(", "),ar=s("em"),eh=o("optional"),th=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),sr=s("code"),nh=o("bool"),oh=o(", "),ir=s("em"),ah=o("optional"),sh=o(", defaults to "),rr=s("code"),ih=o("True"),rh=o(`):
whether to use classifier free guidance or not
negative_prompt (`),lr=s("code"),lh=o("str"),ph=o(" or "),pr=s("code"),dh=o("List[str]"),mh=o(", "),dr=s("em"),ch=o("optional"),gh=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),mr=s("code"),fh=o("negative_prompt_embeds"),uh=o(". instead. If not defined, one has to pass "),cr=s("code"),_h=o("negative_prompt_embeds"),hh=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),gr=s("code"),vh=o("guidance_scale"),bh=o(" is less than "),fr=s("code"),Ih=o("1"),yh=o(`).
prompt_embeds (`),ur=s("code"),wh=o("torch.FloatTensor"),Ph=o(", "),_r=s("em"),Eh=o("optional"),Fh=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),hr=s("em"),$h=o("e.g."),jh=o(` prompt weighting. If not
provided, text embeddings will be generated from `),vr=s("code"),xh=o("prompt"),kh=o(` input argument.
negative_prompt_embeds (`),br=s("code"),qh=o("torch.FloatTensor"),Dh=o(", "),Ir=s("em"),Th=o("optional"),Ch=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),yr=s("em"),Oh=o("e.g."),Lh=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),wr=s("code"),Sh=o("negative_prompt"),Rh=o(` input
argument.`),Yd=l(),tt=s("h2"),Dt=s("a"),Pr=s("span"),f(so.$$.fragment),Nh=l(),Er=s("span"),Mh=o("IFImg2ImgPipeline"),Jd=l(),W=s("div"),f(io.$$.fragment),Gh=l(),_e=s("div"),f(ro.$$.fragment),Uh=l(),Fr=s("p"),Ah=o("Function invoked when calling the pipeline for generation."),Bh=l(),f(Tt.$$.fragment),zh=l(),Ct=s("div"),f(lo.$$.fragment),Wh=l(),Q=s("p"),Xh=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),$r=s("code"),Vh=o("enable_sequential_cpu_offload"),Hh=o(", this method moves one whole model at a time to the GPU when its "),jr=s("code"),Yh=o("forward"),Jh=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),xr=s("code"),Kh=o("enable_sequential_cpu_offload"),Qh=o(", but performance is much better due to the iterative execution of the "),kr=s("code"),Zh=o("unet"),ev=o("."),tv=l(),Ot=s("div"),f(po.$$.fragment),nv=l(),mo=s("p"),ov=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),qr=s("code"),av=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),sv=o("forward` method called."),iv=l(),he=s("div"),f(co.$$.fragment),rv=l(),Dr=s("p"),lv=o("Encodes the prompt into text encoder hidden states."),pv=l(),E=s("p"),dv=o("device: ("),Tr=s("code"),mv=o("torch.device"),cv=o(", "),Cr=s("em"),gv=o("optional"),fv=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),Or=s("code"),uv=o("int"),_v=o(", "),Lr=s("em"),hv=o("optional"),vv=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),Sr=s("code"),bv=o("bool"),Iv=o(", "),Rr=s("em"),yv=o("optional"),wv=o(", defaults to "),Nr=s("code"),Pv=o("True"),Ev=o(`):
whether to use classifier free guidance or not
negative_prompt (`),Mr=s("code"),Fv=o("str"),$v=o(" or "),Gr=s("code"),jv=o("List[str]"),xv=o(", "),Ur=s("em"),kv=o("optional"),qv=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Ar=s("code"),Dv=o("negative_prompt_embeds"),Tv=o(". instead. If not defined, one has to pass "),Br=s("code"),Cv=o("negative_prompt_embeds"),Ov=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),zr=s("code"),Lv=o("guidance_scale"),Sv=o(" is less than "),Wr=s("code"),Rv=o("1"),Nv=o(`).
prompt_embeds (`),Xr=s("code"),Mv=o("torch.FloatTensor"),Gv=o(", "),Vr=s("em"),Uv=o("optional"),Av=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Hr=s("em"),Bv=o("e.g."),zv=o(` prompt weighting. If not
provided, text embeddings will be generated from `),Yr=s("code"),Wv=o("prompt"),Xv=o(` input argument.
negative_prompt_embeds (`),Jr=s("code"),Vv=o("torch.FloatTensor"),Hv=o(", "),Kr=s("em"),Yv=o("optional"),Jv=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),Qr=s("em"),Kv=o("e.g."),Qv=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Zr=s("code"),Zv=o("negative_prompt"),eb=o(` input
argument.`),Kd=l(),nt=s("h2"),Lt=s("a"),el=s("span"),f(go.$$.fragment),tb=l(),tl=s("span"),nb=o("IFImg2ImgSuperResolutionPipeline"),Qd=l(),X=s("div"),f(fo.$$.fragment),ob=l(),ve=s("div"),f(uo.$$.fragment),ab=l(),nl=s("p"),sb=o("Function invoked when calling the pipeline for generation."),ib=l(),f(St.$$.fragment),rb=l(),Rt=s("div"),f(_o.$$.fragment),lb=l(),Z=s("p"),pb=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),ol=s("code"),db=o("enable_sequential_cpu_offload"),mb=o(", this method moves one whole model at a time to the GPU when its "),al=s("code"),cb=o("forward"),gb=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),sl=s("code"),fb=o("enable_sequential_cpu_offload"),ub=o(", but performance is much better due to the iterative execution of the "),il=s("code"),_b=o("unet"),hb=o("."),vb=l(),Nt=s("div"),f(ho.$$.fragment),bb=l(),vo=s("p"),Ib=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),rl=s("code"),yb=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),wb=o("forward` method called."),Pb=l(),be=s("div"),f(bo.$$.fragment),Eb=l(),ll=s("p"),Fb=o("Encodes the prompt into text encoder hidden states."),$b=l(),F=s("p"),jb=o("device: ("),pl=s("code"),xb=o("torch.device"),kb=o(", "),dl=s("em"),qb=o("optional"),Db=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),ml=s("code"),Tb=o("int"),Cb=o(", "),cl=s("em"),Ob=o("optional"),Lb=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),gl=s("code"),Sb=o("bool"),Rb=o(", "),fl=s("em"),Nb=o("optional"),Mb=o(", defaults to "),ul=s("code"),Gb=o("True"),Ub=o(`):
whether to use classifier free guidance or not
negative_prompt (`),_l=s("code"),Ab=o("str"),Bb=o(" or "),hl=s("code"),zb=o("List[str]"),Wb=o(", "),vl=s("em"),Xb=o("optional"),Vb=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),bl=s("code"),Hb=o("negative_prompt_embeds"),Yb=o(". instead. If not defined, one has to pass "),Il=s("code"),Jb=o("negative_prompt_embeds"),Kb=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),yl=s("code"),Qb=o("guidance_scale"),Zb=o(" is less than "),wl=s("code"),eI=o("1"),tI=o(`).
prompt_embeds (`),Pl=s("code"),nI=o("torch.FloatTensor"),oI=o(", "),El=s("em"),aI=o("optional"),sI=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Fl=s("em"),iI=o("e.g."),rI=o(` prompt weighting. If not
provided, text embeddings will be generated from `),$l=s("code"),lI=o("prompt"),pI=o(` input argument.
negative_prompt_embeds (`),jl=s("code"),dI=o("torch.FloatTensor"),mI=o(", "),xl=s("em"),cI=o("optional"),gI=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),kl=s("em"),fI=o("e.g."),uI=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),ql=s("code"),_I=o("negative_prompt"),hI=o(` input
argument.`),Zd=l(),ot=s("h2"),Mt=s("a"),Dl=s("span"),f(Io.$$.fragment),vI=l(),Tl=s("span"),bI=o("IFInpaintingPipeline"),em=l(),V=s("div"),f(yo.$$.fragment),II=l(),Ie=s("div"),f(wo.$$.fragment),yI=l(),Cl=s("p"),wI=o("Function invoked when calling the pipeline for generation."),PI=l(),f(Gt.$$.fragment),EI=l(),Ut=s("div"),f(Po.$$.fragment),FI=l(),ee=s("p"),$I=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ol=s("code"),jI=o("enable_sequential_cpu_offload"),xI=o(", this method moves one whole model at a time to the GPU when its "),Ll=s("code"),kI=o("forward"),qI=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Sl=s("code"),DI=o("enable_sequential_cpu_offload"),TI=o(", but performance is much better due to the iterative execution of the "),Rl=s("code"),CI=o("unet"),OI=o("."),LI=l(),At=s("div"),f(Eo.$$.fragment),SI=l(),Fo=s("p"),RI=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),Nl=s("code"),NI=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),MI=o("forward` method called."),GI=l(),ye=s("div"),f($o.$$.fragment),UI=l(),Ml=s("p"),AI=o("Encodes the prompt into text encoder hidden states."),BI=l(),$=s("p"),zI=o("device: ("),Gl=s("code"),WI=o("torch.device"),XI=o(", "),Ul=s("em"),VI=o("optional"),HI=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),Al=s("code"),YI=o("int"),JI=o(", "),Bl=s("em"),KI=o("optional"),QI=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),zl=s("code"),ZI=o("bool"),e1=o(", "),Wl=s("em"),t1=o("optional"),n1=o(", defaults to "),Xl=s("code"),o1=o("True"),a1=o(`):
whether to use classifier free guidance or not
negative_prompt (`),Vl=s("code"),s1=o("str"),i1=o(" or "),Hl=s("code"),r1=o("List[str]"),l1=o(", "),Yl=s("em"),p1=o("optional"),d1=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Jl=s("code"),m1=o("negative_prompt_embeds"),c1=o(". instead. If not defined, one has to pass "),Kl=s("code"),g1=o("negative_prompt_embeds"),f1=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),Ql=s("code"),u1=o("guidance_scale"),_1=o(" is less than "),Zl=s("code"),h1=o("1"),v1=o(`).
prompt_embeds (`),ep=s("code"),b1=o("torch.FloatTensor"),I1=o(", "),tp=s("em"),y1=o("optional"),w1=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),np=s("em"),P1=o("e.g."),E1=o(` prompt weighting. If not
provided, text embeddings will be generated from `),op=s("code"),F1=o("prompt"),$1=o(` input argument.
negative_prompt_embeds (`),ap=s("code"),j1=o("torch.FloatTensor"),x1=o(", "),sp=s("em"),k1=o("optional"),q1=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),ip=s("em"),D1=o("e.g."),T1=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),rp=s("code"),C1=o("negative_prompt"),O1=o(` input
argument.`),tm=l(),at=s("h2"),Bt=s("a"),lp=s("span"),f(jo.$$.fragment),L1=l(),pp=s("span"),S1=o("IFInpaintingSuperResolutionPipeline"),nm=l(),H=s("div"),f(xo.$$.fragment),R1=l(),we=s("div"),f(ko.$$.fragment),N1=l(),dp=s("p"),M1=o("Function invoked when calling the pipeline for generation."),G1=l(),f(zt.$$.fragment),U1=l(),Wt=s("div"),f(qo.$$.fragment),A1=l(),te=s("p"),B1=o(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),mp=s("code"),z1=o("enable_sequential_cpu_offload"),W1=o(", this method moves one whole model at a time to the GPU when its "),cp=s("code"),X1=o("forward"),V1=o(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),gp=s("code"),H1=o("enable_sequential_cpu_offload"),Y1=o(", but performance is much better due to the iterative execution of the "),fp=s("code"),J1=o("unet"),K1=o("."),Q1=l(),Xt=s("div"),f(Do.$$.fragment),Z1=l(),To=s("p"),ey=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),up=s("code"),ty=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),ny=o("forward` method called."),oy=l(),Pe=s("div"),f(Co.$$.fragment),ay=l(),_p=s("p"),sy=o("Encodes the prompt into text encoder hidden states."),iy=l(),j=s("p"),ry=o("device: ("),hp=s("code"),ly=o("torch.device"),py=o(", "),vp=s("em"),dy=o("optional"),my=o(`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),bp=s("code"),cy=o("int"),gy=o(", "),Ip=s("em"),fy=o("optional"),uy=o(`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),yp=s("code"),_y=o("bool"),hy=o(", "),wp=s("em"),vy=o("optional"),by=o(", defaults to "),Pp=s("code"),Iy=o("True"),yy=o(`):
whether to use classifier free guidance or not
negative_prompt (`),Ep=s("code"),wy=o("str"),Py=o(" or "),Fp=s("code"),Ey=o("List[str]"),Fy=o(", "),$p=s("em"),$y=o("optional"),jy=o(`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),jp=s("code"),xy=o("negative_prompt_embeds"),ky=o(". instead. If not defined, one has to pass "),xp=s("code"),qy=o("negative_prompt_embeds"),Dy=o(`. instead.
Ignored when not using guidance (i.e., ignored if `),kp=s("code"),Ty=o("guidance_scale"),Cy=o(" is less than "),qp=s("code"),Oy=o("1"),Ly=o(`).
prompt_embeds (`),Dp=s("code"),Sy=o("torch.FloatTensor"),Ry=o(", "),Tp=s("em"),Ny=o("optional"),My=o(`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Cp=s("em"),Gy=o("e.g."),Uy=o(` prompt weighting. If not
provided, text embeddings will be generated from `),Op=s("code"),Ay=o("prompt"),By=o(` input argument.
negative_prompt_embeds (`),Lp=s("code"),zy=o("torch.FloatTensor"),Wy=o(", "),Sp=s("em"),Xy=o("optional"),Vy=o(`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),Rp=s("em"),Hy=o("e.g."),Yy=o(` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Np=s("code"),Jy=o("negative_prompt"),Ky=o(` input
argument.`),this.h()},l(n){const m=r$('[data-svelte="svelte-1phssyn"]',document.head);y=i(m,"META",{name:!0,content:!0}),m.forEach(t),N=p(n),L=i(n,"H1",{class:!0});var Oo=r(L);I=i(Oo,"A",{id:!0,class:!0,href:!0});var Mp=r(I);S=i(Mp,"SPAN",{});var Gp=r(S);u(g.$$.fragment,Gp),Gp.forEach(t),Mp.forEach(t),O=p(Oo),Ha=i(Oo,"SPAN",{});var Up=r(Ha);Qm=a(Up,"IF"),Up.forEach(t),Oo.forEach(t),Bp=p(n),Se=i(n,"H2",{class:!0});var Lo=r(Se);st=i(Lo,"A",{id:!0,class:!0,href:!0});var Ap=r(st);Ya=i(Ap,"SPAN",{});var t2=r(Ya);u(Vt.$$.fragment,t2),t2.forEach(t),Ap.forEach(t),Zm=p(Lo),Ja=i(Lo,"SPAN",{});var n2=r(Ja);ec=a(n2,"Overview"),n2.forEach(t),Lo.forEach(t),zp=p(n),No=i(n,"P",{});var o2=r(No);tc=a(o2,`DeepFloyd IF is a novel state-of-the-art open-source text-to-image model with a high degree of photorealism and language understanding.
The model is a modular composed of a frozen text encoder and three cascaded pixel diffusion modules:`),o2.forEach(t),Wp=p(n),ie=i(n,"UL",{});var Ia=r(ie);Ka=i(Ia,"LI",{});var a2=r(Ka);nc=a(a2,"Stage 1: a base model that generates 64x64 px image based on text prompt,"),a2.forEach(t),oc=p(Ia),Qa=i(Ia,"LI",{});var s2=r(Qa);ac=a(s2,"Stage 2: a 64x64 px => 256x256 px super-resolution model, and a"),s2.forEach(t),sc=p(Ia),Ht=i(Ia,"LI",{});var am=r(Ht);ic=a(am,`Stage 3: a 256x256 px => 1024x1024 px super-resolution model
Stage 1 and Stage 2 utilize a frozen text encoder based on the T5 transformer to extract text embeddings,
which are then fed into a UNet architecture enhanced with cross-attention and attention pooling.
Stage 3 is `),Yt=i(am,"A",{href:!0,rel:!0});var i2=r(Yt);rc=a(i2,"Stability\u2019s x4 Upscaling model"),i2.forEach(t),lc=a(am,`.
The result is a highly efficient model that outperforms current state-of-the-art models, achieving a zero-shot FID score of 6.66 on the COCO dataset.
Our work underscores the potential of larger UNet architectures in the first stage of cascaded diffusion models and depicts a promising future for text-to-image synthesis.`),am.forEach(t),Ia.forEach(t),Xp=p(n),Re=i(n,"H2",{class:!0});var sm=r(Re);it=i(sm,"A",{id:!0,class:!0,href:!0});var r2=r(it);Za=i(r2,"SPAN",{});var l2=r(Za);u(Jt.$$.fragment,l2),l2.forEach(t),r2.forEach(t),pc=p(sm),es=i(sm,"SPAN",{});var p2=r(es);dc=a(p2,"Usage"),p2.forEach(t),sm.forEach(t),Vp=p(n),Mo=i(n,"P",{});var d2=r(Mo);mc=a(d2,"Before you can use IF, you need to accept its usage conditions. To do so:"),d2.forEach(t),Hp=p(n),re=i(n,"OL",{});var ya=r(re);Kt=i(ya,"LI",{});var im=r(Kt);cc=a(im,"Make sure to have a "),Qt=i(im,"A",{href:!0,rel:!0});var m2=r(Qt);gc=a(m2,"Hugging Face account"),m2.forEach(t),fc=a(im," and be logged in"),im.forEach(t),uc=p(ya),Zt=i(ya,"LI",{});var rm=r(Zt);_c=a(rm,"Accept the license on the model card of "),en=i(rm,"A",{href:!0,rel:!0});var c2=r(en);hc=a(c2,"DeepFloyd/IF-I-XL-v1.0"),c2.forEach(t),vc=a(rm,". Accepting the license on the stage I model card will auto accept for the other IF models."),rm.forEach(t),bc=p(ya),Go=i(ya,"LI",{});var Qy=r(Go);Ic=a(Qy,"Make sure to login locally. Install "),ts=i(Qy,"CODE",{});var g2=r(ts);yc=a(g2,"huggingface_hub"),g2.forEach(t),Qy.forEach(t),ya.forEach(t),Yp=p(n),u(tn.$$.fragment,n),Jp=p(n),Uo=i(n,"P",{});var f2=r(Uo);wc=a(f2,"run the login function in a Python shell"),f2.forEach(t),Kp=p(n),u(nn.$$.fragment,n),Qp=p(n),rt=i(n,"P",{});var lm=r(rt);Pc=a(lm,"and enter your "),on=i(lm,"A",{href:!0,rel:!0});var u2=r(on);Ec=a(u2,"Hugging Face Hub access token"),u2.forEach(t),Fc=a(lm,"."),lm.forEach(t),Zp=p(n),lt=i(n,"P",{});var pm=r(lt);$c=a(pm,"Next we install "),ns=i(pm,"CODE",{});var _2=r(ns);jc=a(_2,"diffusers"),_2.forEach(t),xc=a(pm," and dependencies:"),pm.forEach(t),ed=p(n),u(an.$$.fragment,n),td=p(n),Ao=i(n,"P",{});var h2=r(Ao);kc=a(h2,"The following sections give more in-detail examples of how to use IF. Specifically:"),h2.forEach(t),nd=p(n),G=i(n,"UL",{});var ne=r(G);os=i(ne,"LI",{});var v2=r(os);Bo=i(v2,"A",{href:!0});var b2=r(Bo);qc=a(b2,"Text-to-Image Generation"),b2.forEach(t),v2.forEach(t),Dc=p(ne),as=i(ne,"LI",{});var I2=r(as);zo=i(I2,"A",{href:!0});var y2=r(zo);Tc=a(y2,"Image-to-Image Generation"),y2.forEach(t),I2.forEach(t),Cc=p(ne),ss=i(ne,"LI",{});var w2=r(ss);Wo=i(w2,"A",{href:!0});var P2=r(Wo);Oc=a(P2,"Inpainting"),P2.forEach(t),w2.forEach(t),Lc=p(ne),is=i(ne,"LI",{});var E2=r(is);Xo=i(E2,"A",{href:!0});var F2=r(Xo);Sc=a(F2,"Reusing model weights"),F2.forEach(t),E2.forEach(t),Rc=p(ne),rs=i(ne,"LI",{});var $2=r(rs);Vo=i($2,"A",{href:!0});var j2=r(Vo);Nc=a(j2,"Speed optimization"),j2.forEach(t),$2.forEach(t),Mc=p(ne),ls=i(ne,"LI",{});var x2=r(ls);Ho=i(x2,"A",{href:!0});var k2=r(Ho);Gc=a(k2,"Memory optimization"),k2.forEach(t),x2.forEach(t),ne.forEach(t),od=p(n),Yo=i(n,"P",{});var q2=r(Yo);ps=i(q2,"STRONG",{});var D2=r(ps);Uc=a(D2,"Available checkpoints"),D2.forEach(t),q2.forEach(t),ad=p(n),le=i(n,"UL",{});var wa=r(le);sn=i(wa,"LI",{});var dm=r(sn);ds=i(dm,"P",{});var T2=r(ds);ms=i(T2,"EM",{});var C2=r(ms);Ac=a(C2,"Stage-1"),C2.forEach(t),T2.forEach(t),Bc=p(dm),Ne=i(dm,"UL",{});var Pa=r(Ne);cs=i(Pa,"LI",{});var O2=r(cs);rn=i(O2,"A",{href:!0,rel:!0});var L2=r(rn);zc=a(L2,"DeepFloyd/IF-I-XL-v1.0"),L2.forEach(t),O2.forEach(t),Wc=p(Pa),gs=i(Pa,"LI",{});var S2=r(gs);ln=i(S2,"A",{href:!0,rel:!0});var R2=r(ln);Xc=a(R2,"DeepFloyd/IF-I-L-v1.0"),R2.forEach(t),S2.forEach(t),Vc=p(Pa),fs=i(Pa,"LI",{});var N2=r(fs);pn=i(N2,"A",{href:!0,rel:!0});var M2=r(pn);Hc=a(M2,"DeepFloyd/IF-I-M-v1.0"),M2.forEach(t),N2.forEach(t),Pa.forEach(t),dm.forEach(t),Yc=p(wa),dn=i(wa,"LI",{});var mm=r(dn);us=i(mm,"P",{});var G2=r(us);_s=i(G2,"EM",{});var U2=r(_s);Jc=a(U2,"Stage-2"),U2.forEach(t),G2.forEach(t),Kc=p(mm),mn=i(mm,"UL",{});var cm=r(mn);hs=i(cm,"LI",{});var A2=r(hs);cn=i(A2,"A",{href:!0,rel:!0});var B2=r(cn);Qc=a(B2,"DeepFloyd/IF-II-L-v1.0"),B2.forEach(t),A2.forEach(t),Zc=p(cm),vs=i(cm,"LI",{});var z2=r(vs);gn=i(z2,"A",{href:!0,rel:!0});var W2=r(gn);eg=a(W2,"DeepFloyd/IF-II-M-v1.0"),W2.forEach(t),z2.forEach(t),cm.forEach(t),mm.forEach(t),tg=p(wa),fn=i(wa,"LI",{});var gm=r(fn);bs=i(gm,"P",{});var X2=r(bs);Is=i(X2,"EM",{});var V2=r(Is);ng=a(V2,"Stage-3"),V2.forEach(t),X2.forEach(t),og=p(gm),ys=i(gm,"UL",{});var H2=r(ys);ws=i(H2,"LI",{});var Y2=r(ws);un=i(Y2,"A",{href:!0,rel:!0});var J2=r(un);ag=a(J2,"stabilityai/stable-diffusion-x4-upscaler"),J2.forEach(t),Y2.forEach(t),H2.forEach(t),gm.forEach(t),wa.forEach(t),sd=p(n),pt=i(n,"P",{});var fm=r(pt);Ps=i(fm,"STRONG",{});var K2=r(Ps);sg=a(K2,"Demo"),K2.forEach(t),ig=p(fm),_n=i(fm,"A",{href:!0,rel:!0});var Q2=r(_n);Jo=i(Q2,"IMG",{src:!0,alt:!0}),Q2.forEach(t),fm.forEach(t),id=p(n),dt=i(n,"P",{});var um=r(dt);Es=i(um,"STRONG",{});var Z2=r(Es);rg=a(Z2,"Google Colab"),Z2.forEach(t),lg=p(um),hn=i(um,"A",{href:!0,rel:!0});var ew=r(hn);Ko=i(ew,"IMG",{src:!0,alt:!0}),ew.forEach(t),um.forEach(t),rd=p(n),Me=i(n,"H3",{class:!0});var _m=r(Me);mt=i(_m,"A",{id:!0,class:!0,href:!0});var tw=r(mt);Fs=i(tw,"SPAN",{});var nw=r(Fs);u(vn.$$.fragment,nw),nw.forEach(t),tw.forEach(t),pg=p(_m),$s=i(_m,"SPAN",{});var ow=r($s);dg=a(ow,"Text-to-Image Generation"),ow.forEach(t),_m.forEach(t),ld=p(n),ct=i(n,"P",{});var hm=r(ct);mg=a(hm,"By default diffusers makes use of "),bn=i(hm,"A",{href:!0,rel:!0});var aw=r(bn);cg=a(aw,"model cpu offloading"),aw.forEach(t),gg=a(hm,`
to run the whole IF pipeline with as little as 14 GB of VRAM.`),hm.forEach(t),pd=p(n),u(In.$$.fragment,n),dd=p(n),Ge=i(n,"H3",{class:!0});var vm=r(Ge);gt=i(vm,"A",{id:!0,class:!0,href:!0});var sw=r(gt);js=i(sw,"SPAN",{});var iw=r(js);u(yn.$$.fragment,iw),iw.forEach(t),sw.forEach(t),fg=p(vm),xs=i(vm,"SPAN",{});var rw=r(xs);ug=a(rw,"Text Guided Image-to-Image Generation"),rw.forEach(t),vm.forEach(t),md=p(n),pe=i(n,"P",{});var Ea=r(pe);_g=a(Ea,`The same IF model weights can be used for text-guided image-to-image translation or image variation.
In this case just make sure to load the weights using the `),Qo=i(Ea,"A",{href:!0});var lw=r(Qo);hg=a(lw,"IFInpaintingPipeline"),lw.forEach(t),vg=a(Ea," and "),Zo=i(Ea,"A",{href:!0});var pw=r(Zo);bg=a(pw,"IFInpaintingSuperResolutionPipeline"),pw.forEach(t),Ig=a(Ea," pipelines."),Ea.forEach(t),cd=p(n),ae=i(n,"P",{});var So=r(ae);ks=i(So,"STRONG",{});var dw=r(ks);yg=a(dw,"Note"),dw.forEach(t),wg=a(So,`: You can also directly move the weights of the text-to-image pipelines to the image-to-image pipelines
without loading them twice by making use of the `),qs=i(So,"CODE",{});var mw=r(qs);Pg=a(mw,"~DiffusionPipeline.components()"),mw.forEach(t),Eg=a(So," function as explained "),ea=i(So,"A",{href:!0});var cw=r(ea);Fg=a(cw,"here"),cw.forEach(t),$g=a(So,"."),So.forEach(t),gd=p(n),u(wn.$$.fragment,n),fd=p(n),Ue=i(n,"H3",{class:!0});var bm=r(Ue);ft=i(bm,"A",{id:!0,class:!0,href:!0});var gw=r(ft);Ds=i(gw,"SPAN",{});var fw=r(Ds);u(Pn.$$.fragment,fw),fw.forEach(t),gw.forEach(t),jg=p(bm),Ts=i(bm,"SPAN",{});var uw=r(Ts);xg=a(uw,"Text Guided Inpainting Generation"),uw.forEach(t),bm.forEach(t),ud=p(n),de=i(n,"P",{});var Fa=r(de);kg=a(Fa,`The same IF model weights can be used for text-guided image-to-image translation or image variation.
In this case just make sure to load the weights using the `),ta=i(Fa,"A",{href:!0});var _w=r(ta);qg=a(_w,"IFInpaintingPipeline"),_w.forEach(t),Dg=a(Fa," and "),na=i(Fa,"A",{href:!0});var hw=r(na);Tg=a(hw,"IFInpaintingSuperResolutionPipeline"),hw.forEach(t),Cg=a(Fa," pipelines."),Fa.forEach(t),_d=p(n),se=i(n,"P",{});var Ro=r(se);Cs=i(Ro,"STRONG",{});var vw=r(Cs);Og=a(vw,"Note"),vw.forEach(t),Lg=a(Ro,`: You can also directly move the weights of the text-to-image pipelines to the image-to-image pipelines
without loading them twice by making use of the `),Os=i(Ro,"CODE",{});var bw=r(Os);Sg=a(bw,"~DiffusionPipeline.components()"),bw.forEach(t),Rg=a(Ro," function as explained "),oa=i(Ro,"A",{href:!0});var Iw=r(oa);Ng=a(Iw,"here"),Iw.forEach(t),Mg=a(Ro,"."),Ro.forEach(t),hd=p(n),u(En.$$.fragment,n),vd=p(n),Ae=i(n,"H3",{class:!0});var Im=r(Ae);ut=i(Im,"A",{id:!0,class:!0,href:!0});var yw=r(ut);Ls=i(yw,"SPAN",{});var ww=r(Ls);u(Fn.$$.fragment,ww),ww.forEach(t),yw.forEach(t),Gg=p(Im),Ss=i(Im,"SPAN",{});var Pw=r(Ss);Ug=a(Pw,"Converting between different pipelines"),Pw.forEach(t),Im.forEach(t),bd=p(n),_t=i(n,"P",{});var ym=r(_t);Ag=a(ym,"In addition to being loaded with "),Rs=i(ym,"CODE",{});var Ew=r(Rs);Bg=a(Ew,"from_pretrained"),Ew.forEach(t),zg=a(ym,", Pipelines can also be loaded directly from each other."),ym.forEach(t),Id=p(n),u($n.$$.fragment,n),yd=p(n),Be=i(n,"H3",{class:!0});var wm=r(Be);ht=i(wm,"A",{id:!0,class:!0,href:!0});var Fw=r(ht);Ns=i(Fw,"SPAN",{});var $w=r(Ns);u(jn.$$.fragment,$w),$w.forEach(t),Fw.forEach(t),Wg=p(wm),Ms=i(wm,"SPAN",{});var jw=r(Ms);Xg=a(jw,"Optimizing for speed"),jw.forEach(t),wm.forEach(t),wd=p(n),aa=i(n,"P",{});var xw=r(aa);Vg=a(xw,"The simplest optimization to run IF faster is to move all model components to the GPU."),xw.forEach(t),Pd=p(n),u(xn.$$.fragment,n),Ed=p(n),sa=i(n,"P",{});var kw=r(sa);Hg=a(kw,"You can also run the diffusion process for a shorter number of timesteps."),kw.forEach(t),Fd=p(n),vt=i(n,"P",{});var Pm=r(vt);Yg=a(Pm,"This can either be done with the "),Gs=i(Pm,"CODE",{});var qw=r(Gs);Jg=a(qw,"num_inference_steps"),qw.forEach(t),Kg=a(Pm," argument"),Pm.forEach(t),$d=p(n),u(kn.$$.fragment,n),jd=p(n),bt=i(n,"P",{});var Em=r(bt);Qg=a(Em,"Or with the "),Us=i(Em,"CODE",{});var Dw=r(Us);Zg=a(Dw,"timesteps"),Dw.forEach(t),ef=a(Em," argument"),Em.forEach(t),xd=p(n),u(qn.$$.fragment,n),kd=p(n),ia=i(n,"P",{});var Tw=r(ia);tf=a(Tw,`When doing image variation or inpainting, you can also decrease the number of timesteps
with the strength argument. The strength argument is the amount of noise to add to
the input image which also determines how many steps to run in the denoising process.
A smaller number will vary the image less but run faster.`),Tw.forEach(t),qd=p(n),u(Dn.$$.fragment,n),Dd=p(n),me=i(n,"P",{});var $a=r(me);nf=a($a,"You can also use "),ra=i($a,"A",{href:!0});var Cw=r(ra);As=i(Cw,"CODE",{});var Ow=r(As);of=a(Ow,"torch.compile"),Ow.forEach(t),Cw.forEach(t),af=a($a,". Note that we have not exhaustively tested "),Bs=i($a,"CODE",{});var Lw=r(Bs);sf=a(Lw,"torch.compile"),Lw.forEach(t),rf=a($a,`
with IF and it might not give expected results.`),$a.forEach(t),Td=p(n),u(Tn.$$.fragment,n),Cd=p(n),ze=i(n,"H3",{class:!0});var Fm=r(ze);It=i(Fm,"A",{id:!0,class:!0,href:!0});var Sw=r(It);zs=i(Sw,"SPAN",{});var Rw=r(zs);u(Cn.$$.fragment,Rw),Rw.forEach(t),Sw.forEach(t),lf=p(Fm),Ws=i(Fm,"SPAN",{});var Nw=r(Ws);pf=a(Nw,"Optimizing for memory"),Nw.forEach(t),Fm.forEach(t),Od=p(n),la=i(n,"P",{});var Mw=r(la);df=a(Mw,"When optimizing for GPU memory, we can use the standard diffusers cpu offloading APIs."),Mw.forEach(t),Ld=p(n),pa=i(n,"P",{});var Gw=r(pa);mf=a(Gw,"Either the model based CPU offloading,"),Gw.forEach(t),Sd=p(n),u(On.$$.fragment,n),Rd=p(n),da=i(n,"P",{});var Uw=r(da);cf=a(Uw,"or the more aggressive layer based CPU offloading."),Uw.forEach(t),Nd=p(n),u(Ln.$$.fragment,n),Md=p(n),ma=i(n,"P",{});var Aw=r(ma);gf=a(Aw,"Additionally, T5 can be loaded in 8bit precision"),Aw.forEach(t),Gd=p(n),u(Sn.$$.fragment,n),Ud=p(n),ca=i(n,"P",{});var Bw=r(ca);ff=a(Bw,`For CPU RAM constrained machines like google colab free tier where we can\u2019t load all
model components to the CPU at once, we can manually only load the pipeline with
the text encoder or unet when the respective model components are needed.`),Bw.forEach(t),Ad=p(n),u(Rn.$$.fragment,n),Bd=p(n),We=i(n,"H2",{class:!0});var $m=r(We);yt=i($m,"A",{id:!0,class:!0,href:!0});var zw=r(yt);Xs=i(zw,"SPAN",{});var Ww=r(Xs);u(Nn.$$.fragment,Ww),Ww.forEach(t),zw.forEach(t),uf=p($m),Vs=i($m,"SPAN",{});var Xw=r(Vs);_f=a(Xw,"Available Pipelines:"),Xw.forEach(t),$m.forEach(t),zd=p(n),wt=i(n,"TABLE",{});var jm=r(wt);Hs=i(jm,"THEAD",{});var Vw=r(Hs);Xe=i(Vw,"TR",{});var ja=r(Xe);Ys=i(ja,"TH",{});var Hw=r(Ys);hf=a(Hw,"Pipeline"),Hw.forEach(t),vf=p(ja),Js=i(ja,"TH",{});var Yw=r(Js);bf=a(Yw,"Tasks"),Yw.forEach(t),If=p(ja),ga=i(ja,"TH",{align:!0});var Jw=r(ga);yf=a(Jw,"Colab"),Jw.forEach(t),ja.forEach(t),Vw.forEach(t),wf=p(jm),A=i(jm,"TBODY",{});var oe=r(A);Ve=i(oe,"TR",{});var xa=r(Ve);Ks=i(xa,"TD",{});var Kw=r(Ks);Mn=i(Kw,"A",{href:!0,rel:!0});var Qw=r(Mn);Pf=a(Qw,"pipeline_if.py"),Qw.forEach(t),Kw.forEach(t),Ef=p(xa),Qs=i(xa,"TD",{});var Zw=r(Qs);Zs=i(Zw,"EM",{});var e0=r(Zs);Ff=a(e0,"Text-to-Image Generation"),e0.forEach(t),Zw.forEach(t),$f=p(xa),fa=i(xa,"TD",{align:!0});var t0=r(fa);jf=a(t0,"-"),t0.forEach(t),xa.forEach(t),xf=p(oe),He=i(oe,"TR",{});var ka=r(He);ei=i(ka,"TD",{});var n0=r(ei);Gn=i(n0,"A",{href:!0,rel:!0});var o0=r(Gn);kf=a(o0,"pipeline_if_superresolution.py"),o0.forEach(t),n0.forEach(t),qf=p(ka),ti=i(ka,"TD",{});var a0=r(ti);ni=i(a0,"EM",{});var s0=r(ni);Df=a(s0,"Text-to-Image Generation"),s0.forEach(t),a0.forEach(t),Tf=p(ka),ua=i(ka,"TD",{align:!0});var i0=r(ua);Cf=a(i0,"-"),i0.forEach(t),ka.forEach(t),Of=p(oe),Ye=i(oe,"TR",{});var qa=r(Ye);oi=i(qa,"TD",{});var r0=r(oi);Un=i(r0,"A",{href:!0,rel:!0});var l0=r(Un);Lf=a(l0,"pipeline_if_img2img.py"),l0.forEach(t),r0.forEach(t),Sf=p(qa),ai=i(qa,"TD",{});var p0=r(ai);si=i(p0,"EM",{});var d0=r(si);Rf=a(d0,"Image-to-Image Generation"),d0.forEach(t),p0.forEach(t),Nf=p(qa),_a=i(qa,"TD",{align:!0});var m0=r(_a);Mf=a(m0,"-"),m0.forEach(t),qa.forEach(t),Gf=p(oe),Je=i(oe,"TR",{});var Da=r(Je);ii=i(Da,"TD",{});var c0=r(ii);An=i(c0,"A",{href:!0,rel:!0});var g0=r(An);Uf=a(g0,"pipeline_if_img2img_superresolution.py"),g0.forEach(t),c0.forEach(t),Af=p(Da),ri=i(Da,"TD",{});var f0=r(ri);li=i(f0,"EM",{});var u0=r(li);Bf=a(u0,"Image-to-Image Generation"),u0.forEach(t),f0.forEach(t),zf=p(Da),ha=i(Da,"TD",{align:!0});var _0=r(ha);Wf=a(_0,"-"),_0.forEach(t),Da.forEach(t),Xf=p(oe),Ke=i(oe,"TR",{});var Ta=r(Ke);pi=i(Ta,"TD",{});var h0=r(pi);Bn=i(h0,"A",{href:!0,rel:!0});var v0=r(Bn);Vf=a(v0,"pipeline_if_inpainting.py"),v0.forEach(t),h0.forEach(t),Hf=p(Ta),di=i(Ta,"TD",{});var b0=r(di);mi=i(b0,"EM",{});var I0=r(mi);Yf=a(I0,"Image-to-Image Generation"),I0.forEach(t),b0.forEach(t),Jf=p(Ta),va=i(Ta,"TD",{align:!0});var y0=r(va);Kf=a(y0,"-"),y0.forEach(t),Ta.forEach(t),Qf=p(oe),Qe=i(oe,"TR",{});var Ca=r(Qe);ci=i(Ca,"TD",{});var w0=r(ci);zn=i(w0,"A",{href:!0,rel:!0});var P0=r(zn);Zf=a(P0,"pipeline_if_inpainting_superresolution.py"),P0.forEach(t),w0.forEach(t),eu=p(Ca),gi=i(Ca,"TD",{});var E0=r(gi);fi=i(E0,"EM",{});var F0=r(fi);tu=a(F0,"Image-to-Image Generation"),F0.forEach(t),E0.forEach(t),nu=p(Ca),ba=i(Ca,"TD",{align:!0});var $0=r(ba);ou=a($0,"-"),$0.forEach(t),Ca.forEach(t),oe.forEach(t),jm.forEach(t),Wd=p(n),Ze=i(n,"H2",{class:!0});var xm=r(Ze);Pt=i(xm,"A",{id:!0,class:!0,href:!0});var j0=r(Pt);ui=i(j0,"SPAN",{});var x0=r(ui);u(Wn.$$.fragment,x0),x0.forEach(t),j0.forEach(t),au=p(xm),_i=i(xm,"SPAN",{});var k0=r(_i);su=a(k0,"IFPipeline"),k0.forEach(t),xm.forEach(t),Xd=p(n),B=i(n,"DIV",{class:!0});var Ee=r(B);u(Xn.$$.fragment,Ee),iu=p(Ee),ce=i(Ee,"DIV",{class:!0});var Oa=r(ce);u(Vn.$$.fragment,Oa),ru=p(Oa),hi=i(Oa,"P",{});var q0=r(hi);lu=a(q0,"Function invoked when calling the pipeline for generation."),q0.forEach(t),pu=p(Oa),u(Et.$$.fragment,Oa),Oa.forEach(t),du=p(Ee),Ft=i(Ee,"DIV",{class:!0});var km=r(Ft);u(Hn.$$.fragment,km),mu=p(km),J=i(km,"P",{});var Fe=r(J);cu=a(Fe,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),vi=i(Fe,"CODE",{});var D0=r(vi);gu=a(D0,"enable_sequential_cpu_offload"),D0.forEach(t),fu=a(Fe,", this method moves one whole model at a time to the GPU when its "),bi=i(Fe,"CODE",{});var T0=r(bi);uu=a(T0,"forward"),T0.forEach(t),_u=a(Fe,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ii=i(Fe,"CODE",{});var C0=r(Ii);hu=a(C0,"enable_sequential_cpu_offload"),C0.forEach(t),vu=a(Fe,", but performance is much better due to the iterative execution of the "),yi=i(Fe,"CODE",{});var O0=r(yi);bu=a(O0,"unet"),O0.forEach(t),Iu=a(Fe,"."),Fe.forEach(t),km.forEach(t),yu=p(Ee),$t=i(Ee,"DIV",{class:!0});var qm=r($t);u(Yn.$$.fragment,qm),wu=p(qm),Jn=i(qm,"P",{});var Dm=r(Jn);Pu=a(Dm,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),wi=i(Dm,"CODE",{});var L0=r(wi);Eu=a(L0,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),L0.forEach(t),Fu=a(Dm,"forward` method called."),Dm.forEach(t),qm.forEach(t),$u=p(Ee),ge=i(Ee,"DIV",{class:!0});var La=r(ge);u(Kn.$$.fragment,La),ju=p(La),Pi=i(La,"P",{});var S0=r(Pi);xu=a(S0,"Encodes the prompt into text encoder hidden states."),S0.forEach(t),ku=p(La),w=i(La,"P",{});var x=r(w);qu=a(x,"device: ("),Ei=i(x,"CODE",{});var R0=r(Ei);Du=a(R0,"torch.device"),R0.forEach(t),Tu=a(x,", "),Fi=i(x,"EM",{});var N0=r(Fi);Cu=a(N0,"optional"),N0.forEach(t),Ou=a(x,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),$i=i(x,"CODE",{});var M0=r($i);Lu=a(M0,"int"),M0.forEach(t),Su=a(x,", "),ji=i(x,"EM",{});var G0=r(ji);Ru=a(G0,"optional"),G0.forEach(t),Nu=a(x,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),xi=i(x,"CODE",{});var U0=r(xi);Mu=a(U0,"bool"),U0.forEach(t),Gu=a(x,", "),ki=i(x,"EM",{});var A0=r(ki);Uu=a(A0,"optional"),A0.forEach(t),Au=a(x,", defaults to "),qi=i(x,"CODE",{});var B0=r(qi);Bu=a(B0,"True"),B0.forEach(t),zu=a(x,`):
whether to use classifier free guidance or not
negative_prompt (`),Di=i(x,"CODE",{});var z0=r(Di);Wu=a(z0,"str"),z0.forEach(t),Xu=a(x," or "),Ti=i(x,"CODE",{});var W0=r(Ti);Vu=a(W0,"List[str]"),W0.forEach(t),Hu=a(x,", "),Ci=i(x,"EM",{});var X0=r(Ci);Yu=a(X0,"optional"),X0.forEach(t),Ju=a(x,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Oi=i(x,"CODE",{});var V0=r(Oi);Ku=a(V0,"negative_prompt_embeds"),V0.forEach(t),Qu=a(x,". instead. If not defined, one has to pass "),Li=i(x,"CODE",{});var H0=r(Li);Zu=a(H0,"negative_prompt_embeds"),H0.forEach(t),e_=a(x,`. instead.
Ignored when not using guidance (i.e., ignored if `),Si=i(x,"CODE",{});var Y0=r(Si);t_=a(Y0,"guidance_scale"),Y0.forEach(t),n_=a(x," is less than "),Ri=i(x,"CODE",{});var J0=r(Ri);o_=a(J0,"1"),J0.forEach(t),a_=a(x,`).
prompt_embeds (`),Ni=i(x,"CODE",{});var K0=r(Ni);s_=a(K0,"torch.FloatTensor"),K0.forEach(t),i_=a(x,", "),Mi=i(x,"EM",{});var Q0=r(Mi);r_=a(Q0,"optional"),Q0.forEach(t),l_=a(x,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Gi=i(x,"EM",{});var Z0=r(Gi);p_=a(Z0,"e.g."),Z0.forEach(t),d_=a(x,` prompt weighting. If not
provided, text embeddings will be generated from `),Ui=i(x,"CODE",{});var eP=r(Ui);m_=a(eP,"prompt"),eP.forEach(t),c_=a(x,` input argument.
negative_prompt_embeds (`),Ai=i(x,"CODE",{});var tP=r(Ai);g_=a(tP,"torch.FloatTensor"),tP.forEach(t),f_=a(x,", "),Bi=i(x,"EM",{});var nP=r(Bi);u_=a(nP,"optional"),nP.forEach(t),__=a(x,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),zi=i(x,"EM",{});var oP=r(zi);h_=a(oP,"e.g."),oP.forEach(t),v_=a(x,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Wi=i(x,"CODE",{});var aP=r(Wi);b_=a(aP,"negative_prompt"),aP.forEach(t),I_=a(x,` input
argument.`),x.forEach(t),La.forEach(t),Ee.forEach(t),Vd=p(n),et=i(n,"H2",{class:!0});var Tm=r(et);jt=i(Tm,"A",{id:!0,class:!0,href:!0});var sP=r(jt);Xi=i(sP,"SPAN",{});var iP=r(Xi);u(Qn.$$.fragment,iP),iP.forEach(t),sP.forEach(t),y_=p(Tm),Vi=i(Tm,"SPAN",{});var rP=r(Vi);w_=a(rP,"IFSuperResolutionPipeline"),rP.forEach(t),Tm.forEach(t),Hd=p(n),z=i(n,"DIV",{class:!0});var $e=r(z);u(Zn.$$.fragment,$e),P_=p($e),fe=i($e,"DIV",{class:!0});var Sa=r(fe);u(eo.$$.fragment,Sa),E_=p(Sa),Hi=i(Sa,"P",{});var lP=r(Hi);F_=a(lP,"Function invoked when calling the pipeline for generation."),lP.forEach(t),$_=p(Sa),u(xt.$$.fragment,Sa),Sa.forEach(t),j_=p($e),kt=i($e,"DIV",{class:!0});var Cm=r(kt);u(to.$$.fragment,Cm),x_=p(Cm),K=i(Cm,"P",{});var je=r(K);k_=a(je,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Yi=i(je,"CODE",{});var pP=r(Yi);q_=a(pP,"enable_sequential_cpu_offload"),pP.forEach(t),D_=a(je,", this method moves one whole model at a time to the GPU when its "),Ji=i(je,"CODE",{});var dP=r(Ji);T_=a(dP,"forward"),dP.forEach(t),C_=a(je,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ki=i(je,"CODE",{});var mP=r(Ki);O_=a(mP,"enable_sequential_cpu_offload"),mP.forEach(t),L_=a(je,", but performance is much better due to the iterative execution of the "),Qi=i(je,"CODE",{});var cP=r(Qi);S_=a(cP,"unet"),cP.forEach(t),R_=a(je,"."),je.forEach(t),Cm.forEach(t),N_=p($e),qt=i($e,"DIV",{class:!0});var Om=r(qt);u(no.$$.fragment,Om),M_=p(Om),oo=i(Om,"P",{});var Lm=r(oo);G_=a(Lm,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),Zi=i(Lm,"CODE",{});var gP=r(Zi);U_=a(gP,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),gP.forEach(t),A_=a(Lm,"forward` method called."),Lm.forEach(t),Om.forEach(t),B_=p($e),ue=i($e,"DIV",{class:!0});var Ra=r(ue);u(ao.$$.fragment,Ra),z_=p(Ra),er=i(Ra,"P",{});var fP=r(er);W_=a(fP,"Encodes the prompt into text encoder hidden states."),fP.forEach(t),X_=p(Ra),P=i(Ra,"P",{});var k=r(P);V_=a(k,"device: ("),tr=i(k,"CODE",{});var uP=r(tr);H_=a(uP,"torch.device"),uP.forEach(t),Y_=a(k,", "),nr=i(k,"EM",{});var _P=r(nr);J_=a(_P,"optional"),_P.forEach(t),K_=a(k,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),or=i(k,"CODE",{});var hP=r(or);Q_=a(hP,"int"),hP.forEach(t),Z_=a(k,", "),ar=i(k,"EM",{});var vP=r(ar);eh=a(vP,"optional"),vP.forEach(t),th=a(k,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),sr=i(k,"CODE",{});var bP=r(sr);nh=a(bP,"bool"),bP.forEach(t),oh=a(k,", "),ir=i(k,"EM",{});var IP=r(ir);ah=a(IP,"optional"),IP.forEach(t),sh=a(k,", defaults to "),rr=i(k,"CODE",{});var yP=r(rr);ih=a(yP,"True"),yP.forEach(t),rh=a(k,`):
whether to use classifier free guidance or not
negative_prompt (`),lr=i(k,"CODE",{});var wP=r(lr);lh=a(wP,"str"),wP.forEach(t),ph=a(k," or "),pr=i(k,"CODE",{});var PP=r(pr);dh=a(PP,"List[str]"),PP.forEach(t),mh=a(k,", "),dr=i(k,"EM",{});var EP=r(dr);ch=a(EP,"optional"),EP.forEach(t),gh=a(k,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),mr=i(k,"CODE",{});var FP=r(mr);fh=a(FP,"negative_prompt_embeds"),FP.forEach(t),uh=a(k,". instead. If not defined, one has to pass "),cr=i(k,"CODE",{});var $P=r(cr);_h=a($P,"negative_prompt_embeds"),$P.forEach(t),hh=a(k,`. instead.
Ignored when not using guidance (i.e., ignored if `),gr=i(k,"CODE",{});var jP=r(gr);vh=a(jP,"guidance_scale"),jP.forEach(t),bh=a(k," is less than "),fr=i(k,"CODE",{});var xP=r(fr);Ih=a(xP,"1"),xP.forEach(t),yh=a(k,`).
prompt_embeds (`),ur=i(k,"CODE",{});var kP=r(ur);wh=a(kP,"torch.FloatTensor"),kP.forEach(t),Ph=a(k,", "),_r=i(k,"EM",{});var qP=r(_r);Eh=a(qP,"optional"),qP.forEach(t),Fh=a(k,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),hr=i(k,"EM",{});var DP=r(hr);$h=a(DP,"e.g."),DP.forEach(t),jh=a(k,` prompt weighting. If not
provided, text embeddings will be generated from `),vr=i(k,"CODE",{});var TP=r(vr);xh=a(TP,"prompt"),TP.forEach(t),kh=a(k,` input argument.
negative_prompt_embeds (`),br=i(k,"CODE",{});var CP=r(br);qh=a(CP,"torch.FloatTensor"),CP.forEach(t),Dh=a(k,", "),Ir=i(k,"EM",{});var OP=r(Ir);Th=a(OP,"optional"),OP.forEach(t),Ch=a(k,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),yr=i(k,"EM",{});var LP=r(yr);Oh=a(LP,"e.g."),LP.forEach(t),Lh=a(k,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),wr=i(k,"CODE",{});var SP=r(wr);Sh=a(SP,"negative_prompt"),SP.forEach(t),Rh=a(k,` input
argument.`),k.forEach(t),Ra.forEach(t),$e.forEach(t),Yd=p(n),tt=i(n,"H2",{class:!0});var Sm=r(tt);Dt=i(Sm,"A",{id:!0,class:!0,href:!0});var RP=r(Dt);Pr=i(RP,"SPAN",{});var NP=r(Pr);u(so.$$.fragment,NP),NP.forEach(t),RP.forEach(t),Nh=p(Sm),Er=i(Sm,"SPAN",{});var MP=r(Er);Mh=a(MP,"IFImg2ImgPipeline"),MP.forEach(t),Sm.forEach(t),Jd=p(n),W=i(n,"DIV",{class:!0});var xe=r(W);u(io.$$.fragment,xe),Gh=p(xe),_e=i(xe,"DIV",{class:!0});var Na=r(_e);u(ro.$$.fragment,Na),Uh=p(Na),Fr=i(Na,"P",{});var GP=r(Fr);Ah=a(GP,"Function invoked when calling the pipeline for generation."),GP.forEach(t),Bh=p(Na),u(Tt.$$.fragment,Na),Na.forEach(t),zh=p(xe),Ct=i(xe,"DIV",{class:!0});var Rm=r(Ct);u(lo.$$.fragment,Rm),Wh=p(Rm),Q=i(Rm,"P",{});var ke=r(Q);Xh=a(ke,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),$r=i(ke,"CODE",{});var UP=r($r);Vh=a(UP,"enable_sequential_cpu_offload"),UP.forEach(t),Hh=a(ke,", this method moves one whole model at a time to the GPU when its "),jr=i(ke,"CODE",{});var AP=r(jr);Yh=a(AP,"forward"),AP.forEach(t),Jh=a(ke,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),xr=i(ke,"CODE",{});var BP=r(xr);Kh=a(BP,"enable_sequential_cpu_offload"),BP.forEach(t),Qh=a(ke,", but performance is much better due to the iterative execution of the "),kr=i(ke,"CODE",{});var zP=r(kr);Zh=a(zP,"unet"),zP.forEach(t),ev=a(ke,"."),ke.forEach(t),Rm.forEach(t),tv=p(xe),Ot=i(xe,"DIV",{class:!0});var Nm=r(Ot);u(po.$$.fragment,Nm),nv=p(Nm),mo=i(Nm,"P",{});var Mm=r(mo);ov=a(Mm,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),qr=i(Mm,"CODE",{});var WP=r(qr);av=a(WP,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),WP.forEach(t),sv=a(Mm,"forward` method called."),Mm.forEach(t),Nm.forEach(t),iv=p(xe),he=i(xe,"DIV",{class:!0});var Ma=r(he);u(co.$$.fragment,Ma),rv=p(Ma),Dr=i(Ma,"P",{});var XP=r(Dr);lv=a(XP,"Encodes the prompt into text encoder hidden states."),XP.forEach(t),pv=p(Ma),E=i(Ma,"P",{});var q=r(E);dv=a(q,"device: ("),Tr=i(q,"CODE",{});var VP=r(Tr);mv=a(VP,"torch.device"),VP.forEach(t),cv=a(q,", "),Cr=i(q,"EM",{});var HP=r(Cr);gv=a(HP,"optional"),HP.forEach(t),fv=a(q,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),Or=i(q,"CODE",{});var YP=r(Or);uv=a(YP,"int"),YP.forEach(t),_v=a(q,", "),Lr=i(q,"EM",{});var JP=r(Lr);hv=a(JP,"optional"),JP.forEach(t),vv=a(q,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),Sr=i(q,"CODE",{});var KP=r(Sr);bv=a(KP,"bool"),KP.forEach(t),Iv=a(q,", "),Rr=i(q,"EM",{});var QP=r(Rr);yv=a(QP,"optional"),QP.forEach(t),wv=a(q,", defaults to "),Nr=i(q,"CODE",{});var ZP=r(Nr);Pv=a(ZP,"True"),ZP.forEach(t),Ev=a(q,`):
whether to use classifier free guidance or not
negative_prompt (`),Mr=i(q,"CODE",{});var eE=r(Mr);Fv=a(eE,"str"),eE.forEach(t),$v=a(q," or "),Gr=i(q,"CODE",{});var tE=r(Gr);jv=a(tE,"List[str]"),tE.forEach(t),xv=a(q,", "),Ur=i(q,"EM",{});var nE=r(Ur);kv=a(nE,"optional"),nE.forEach(t),qv=a(q,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Ar=i(q,"CODE",{});var oE=r(Ar);Dv=a(oE,"negative_prompt_embeds"),oE.forEach(t),Tv=a(q,". instead. If not defined, one has to pass "),Br=i(q,"CODE",{});var aE=r(Br);Cv=a(aE,"negative_prompt_embeds"),aE.forEach(t),Ov=a(q,`. instead.
Ignored when not using guidance (i.e., ignored if `),zr=i(q,"CODE",{});var sE=r(zr);Lv=a(sE,"guidance_scale"),sE.forEach(t),Sv=a(q," is less than "),Wr=i(q,"CODE",{});var iE=r(Wr);Rv=a(iE,"1"),iE.forEach(t),Nv=a(q,`).
prompt_embeds (`),Xr=i(q,"CODE",{});var rE=r(Xr);Mv=a(rE,"torch.FloatTensor"),rE.forEach(t),Gv=a(q,", "),Vr=i(q,"EM",{});var lE=r(Vr);Uv=a(lE,"optional"),lE.forEach(t),Av=a(q,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Hr=i(q,"EM",{});var pE=r(Hr);Bv=a(pE,"e.g."),pE.forEach(t),zv=a(q,` prompt weighting. If not
provided, text embeddings will be generated from `),Yr=i(q,"CODE",{});var dE=r(Yr);Wv=a(dE,"prompt"),dE.forEach(t),Xv=a(q,` input argument.
negative_prompt_embeds (`),Jr=i(q,"CODE",{});var mE=r(Jr);Vv=a(mE,"torch.FloatTensor"),mE.forEach(t),Hv=a(q,", "),Kr=i(q,"EM",{});var cE=r(Kr);Yv=a(cE,"optional"),cE.forEach(t),Jv=a(q,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),Qr=i(q,"EM",{});var gE=r(Qr);Kv=a(gE,"e.g."),gE.forEach(t),Qv=a(q,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Zr=i(q,"CODE",{});var fE=r(Zr);Zv=a(fE,"negative_prompt"),fE.forEach(t),eb=a(q,` input
argument.`),q.forEach(t),Ma.forEach(t),xe.forEach(t),Kd=p(n),nt=i(n,"H2",{class:!0});var Gm=r(nt);Lt=i(Gm,"A",{id:!0,class:!0,href:!0});var uE=r(Lt);el=i(uE,"SPAN",{});var _E=r(el);u(go.$$.fragment,_E),_E.forEach(t),uE.forEach(t),tb=p(Gm),tl=i(Gm,"SPAN",{});var hE=r(tl);nb=a(hE,"IFImg2ImgSuperResolutionPipeline"),hE.forEach(t),Gm.forEach(t),Qd=p(n),X=i(n,"DIV",{class:!0});var qe=r(X);u(fo.$$.fragment,qe),ob=p(qe),ve=i(qe,"DIV",{class:!0});var Ga=r(ve);u(uo.$$.fragment,Ga),ab=p(Ga),nl=i(Ga,"P",{});var vE=r(nl);sb=a(vE,"Function invoked when calling the pipeline for generation."),vE.forEach(t),ib=p(Ga),u(St.$$.fragment,Ga),Ga.forEach(t),rb=p(qe),Rt=i(qe,"DIV",{class:!0});var Um=r(Rt);u(_o.$$.fragment,Um),lb=p(Um),Z=i(Um,"P",{});var De=r(Z);pb=a(De,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),ol=i(De,"CODE",{});var bE=r(ol);db=a(bE,"enable_sequential_cpu_offload"),bE.forEach(t),mb=a(De,", this method moves one whole model at a time to the GPU when its "),al=i(De,"CODE",{});var IE=r(al);cb=a(IE,"forward"),IE.forEach(t),gb=a(De,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),sl=i(De,"CODE",{});var yE=r(sl);fb=a(yE,"enable_sequential_cpu_offload"),yE.forEach(t),ub=a(De,", but performance is much better due to the iterative execution of the "),il=i(De,"CODE",{});var wE=r(il);_b=a(wE,"unet"),wE.forEach(t),hb=a(De,"."),De.forEach(t),Um.forEach(t),vb=p(qe),Nt=i(qe,"DIV",{class:!0});var Am=r(Nt);u(ho.$$.fragment,Am),bb=p(Am),vo=i(Am,"P",{});var Bm=r(vo);Ib=a(Bm,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),rl=i(Bm,"CODE",{});var PE=r(rl);yb=a(PE,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),PE.forEach(t),wb=a(Bm,"forward` method called."),Bm.forEach(t),Am.forEach(t),Pb=p(qe),be=i(qe,"DIV",{class:!0});var Ua=r(be);u(bo.$$.fragment,Ua),Eb=p(Ua),ll=i(Ua,"P",{});var EE=r(ll);Fb=a(EE,"Encodes the prompt into text encoder hidden states."),EE.forEach(t),$b=p(Ua),F=i(Ua,"P",{});var D=r(F);jb=a(D,"device: ("),pl=i(D,"CODE",{});var FE=r(pl);xb=a(FE,"torch.device"),FE.forEach(t),kb=a(D,", "),dl=i(D,"EM",{});var $E=r(dl);qb=a($E,"optional"),$E.forEach(t),Db=a(D,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),ml=i(D,"CODE",{});var jE=r(ml);Tb=a(jE,"int"),jE.forEach(t),Cb=a(D,", "),cl=i(D,"EM",{});var xE=r(cl);Ob=a(xE,"optional"),xE.forEach(t),Lb=a(D,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),gl=i(D,"CODE",{});var kE=r(gl);Sb=a(kE,"bool"),kE.forEach(t),Rb=a(D,", "),fl=i(D,"EM",{});var qE=r(fl);Nb=a(qE,"optional"),qE.forEach(t),Mb=a(D,", defaults to "),ul=i(D,"CODE",{});var DE=r(ul);Gb=a(DE,"True"),DE.forEach(t),Ub=a(D,`):
whether to use classifier free guidance or not
negative_prompt (`),_l=i(D,"CODE",{});var TE=r(_l);Ab=a(TE,"str"),TE.forEach(t),Bb=a(D," or "),hl=i(D,"CODE",{});var CE=r(hl);zb=a(CE,"List[str]"),CE.forEach(t),Wb=a(D,", "),vl=i(D,"EM",{});var OE=r(vl);Xb=a(OE,"optional"),OE.forEach(t),Vb=a(D,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),bl=i(D,"CODE",{});var LE=r(bl);Hb=a(LE,"negative_prompt_embeds"),LE.forEach(t),Yb=a(D,". instead. If not defined, one has to pass "),Il=i(D,"CODE",{});var SE=r(Il);Jb=a(SE,"negative_prompt_embeds"),SE.forEach(t),Kb=a(D,`. instead.
Ignored when not using guidance (i.e., ignored if `),yl=i(D,"CODE",{});var RE=r(yl);Qb=a(RE,"guidance_scale"),RE.forEach(t),Zb=a(D," is less than "),wl=i(D,"CODE",{});var NE=r(wl);eI=a(NE,"1"),NE.forEach(t),tI=a(D,`).
prompt_embeds (`),Pl=i(D,"CODE",{});var ME=r(Pl);nI=a(ME,"torch.FloatTensor"),ME.forEach(t),oI=a(D,", "),El=i(D,"EM",{});var GE=r(El);aI=a(GE,"optional"),GE.forEach(t),sI=a(D,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Fl=i(D,"EM",{});var UE=r(Fl);iI=a(UE,"e.g."),UE.forEach(t),rI=a(D,` prompt weighting. If not
provided, text embeddings will be generated from `),$l=i(D,"CODE",{});var AE=r($l);lI=a(AE,"prompt"),AE.forEach(t),pI=a(D,` input argument.
negative_prompt_embeds (`),jl=i(D,"CODE",{});var BE=r(jl);dI=a(BE,"torch.FloatTensor"),BE.forEach(t),mI=a(D,", "),xl=i(D,"EM",{});var zE=r(xl);cI=a(zE,"optional"),zE.forEach(t),gI=a(D,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),kl=i(D,"EM",{});var WE=r(kl);fI=a(WE,"e.g."),WE.forEach(t),uI=a(D,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),ql=i(D,"CODE",{});var XE=r(ql);_I=a(XE,"negative_prompt"),XE.forEach(t),hI=a(D,` input
argument.`),D.forEach(t),Ua.forEach(t),qe.forEach(t),Zd=p(n),ot=i(n,"H2",{class:!0});var zm=r(ot);Mt=i(zm,"A",{id:!0,class:!0,href:!0});var VE=r(Mt);Dl=i(VE,"SPAN",{});var HE=r(Dl);u(Io.$$.fragment,HE),HE.forEach(t),VE.forEach(t),vI=p(zm),Tl=i(zm,"SPAN",{});var YE=r(Tl);bI=a(YE,"IFInpaintingPipeline"),YE.forEach(t),zm.forEach(t),em=p(n),V=i(n,"DIV",{class:!0});var Te=r(V);u(yo.$$.fragment,Te),II=p(Te),Ie=i(Te,"DIV",{class:!0});var Aa=r(Ie);u(wo.$$.fragment,Aa),yI=p(Aa),Cl=i(Aa,"P",{});var JE=r(Cl);wI=a(JE,"Function invoked when calling the pipeline for generation."),JE.forEach(t),PI=p(Aa),u(Gt.$$.fragment,Aa),Aa.forEach(t),EI=p(Te),Ut=i(Te,"DIV",{class:!0});var Wm=r(Ut);u(Po.$$.fragment,Wm),FI=p(Wm),ee=i(Wm,"P",{});var Ce=r(ee);$I=a(Ce,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ol=i(Ce,"CODE",{});var KE=r(Ol);jI=a(KE,"enable_sequential_cpu_offload"),KE.forEach(t),xI=a(Ce,", this method moves one whole model at a time to the GPU when its "),Ll=i(Ce,"CODE",{});var QE=r(Ll);kI=a(QE,"forward"),QE.forEach(t),qI=a(Ce,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Sl=i(Ce,"CODE",{});var ZE=r(Sl);DI=a(ZE,"enable_sequential_cpu_offload"),ZE.forEach(t),TI=a(Ce,", but performance is much better due to the iterative execution of the "),Rl=i(Ce,"CODE",{});var eF=r(Rl);CI=a(eF,"unet"),eF.forEach(t),OI=a(Ce,"."),Ce.forEach(t),Wm.forEach(t),LI=p(Te),At=i(Te,"DIV",{class:!0});var Xm=r(At);u(Eo.$$.fragment,Xm),SI=p(Xm),Fo=i(Xm,"P",{});var Vm=r(Fo);RI=a(Vm,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),Nl=i(Vm,"CODE",{});var tF=r(Nl);NI=a(tF,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),tF.forEach(t),MI=a(Vm,"forward` method called."),Vm.forEach(t),Xm.forEach(t),GI=p(Te),ye=i(Te,"DIV",{class:!0});var Ba=r(ye);u($o.$$.fragment,Ba),UI=p(Ba),Ml=i(Ba,"P",{});var nF=r(Ml);AI=a(nF,"Encodes the prompt into text encoder hidden states."),nF.forEach(t),BI=p(Ba),$=i(Ba,"P",{});var T=r($);zI=a(T,"device: ("),Gl=i(T,"CODE",{});var oF=r(Gl);WI=a(oF,"torch.device"),oF.forEach(t),XI=a(T,", "),Ul=i(T,"EM",{});var aF=r(Ul);VI=a(aF,"optional"),aF.forEach(t),HI=a(T,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),Al=i(T,"CODE",{});var sF=r(Al);YI=a(sF,"int"),sF.forEach(t),JI=a(T,", "),Bl=i(T,"EM",{});var iF=r(Bl);KI=a(iF,"optional"),iF.forEach(t),QI=a(T,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),zl=i(T,"CODE",{});var rF=r(zl);ZI=a(rF,"bool"),rF.forEach(t),e1=a(T,", "),Wl=i(T,"EM",{});var lF=r(Wl);t1=a(lF,"optional"),lF.forEach(t),n1=a(T,", defaults to "),Xl=i(T,"CODE",{});var pF=r(Xl);o1=a(pF,"True"),pF.forEach(t),a1=a(T,`):
whether to use classifier free guidance or not
negative_prompt (`),Vl=i(T,"CODE",{});var dF=r(Vl);s1=a(dF,"str"),dF.forEach(t),i1=a(T," or "),Hl=i(T,"CODE",{});var mF=r(Hl);r1=a(mF,"List[str]"),mF.forEach(t),l1=a(T,", "),Yl=i(T,"EM",{});var cF=r(Yl);p1=a(cF,"optional"),cF.forEach(t),d1=a(T,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),Jl=i(T,"CODE",{});var gF=r(Jl);m1=a(gF,"negative_prompt_embeds"),gF.forEach(t),c1=a(T,". instead. If not defined, one has to pass "),Kl=i(T,"CODE",{});var fF=r(Kl);g1=a(fF,"negative_prompt_embeds"),fF.forEach(t),f1=a(T,`. instead.
Ignored when not using guidance (i.e., ignored if `),Ql=i(T,"CODE",{});var uF=r(Ql);u1=a(uF,"guidance_scale"),uF.forEach(t),_1=a(T," is less than "),Zl=i(T,"CODE",{});var _F=r(Zl);h1=a(_F,"1"),_F.forEach(t),v1=a(T,`).
prompt_embeds (`),ep=i(T,"CODE",{});var hF=r(ep);b1=a(hF,"torch.FloatTensor"),hF.forEach(t),I1=a(T,", "),tp=i(T,"EM",{});var vF=r(tp);y1=a(vF,"optional"),vF.forEach(t),w1=a(T,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),np=i(T,"EM",{});var bF=r(np);P1=a(bF,"e.g."),bF.forEach(t),E1=a(T,` prompt weighting. If not
provided, text embeddings will be generated from `),op=i(T,"CODE",{});var IF=r(op);F1=a(IF,"prompt"),IF.forEach(t),$1=a(T,` input argument.
negative_prompt_embeds (`),ap=i(T,"CODE",{});var yF=r(ap);j1=a(yF,"torch.FloatTensor"),yF.forEach(t),x1=a(T,", "),sp=i(T,"EM",{});var wF=r(sp);k1=a(wF,"optional"),wF.forEach(t),q1=a(T,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),ip=i(T,"EM",{});var PF=r(ip);D1=a(PF,"e.g."),PF.forEach(t),T1=a(T,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),rp=i(T,"CODE",{});var EF=r(rp);C1=a(EF,"negative_prompt"),EF.forEach(t),O1=a(T,` input
argument.`),T.forEach(t),Ba.forEach(t),Te.forEach(t),tm=p(n),at=i(n,"H2",{class:!0});var Hm=r(at);Bt=i(Hm,"A",{id:!0,class:!0,href:!0});var FF=r(Bt);lp=i(FF,"SPAN",{});var $F=r(lp);u(jo.$$.fragment,$F),$F.forEach(t),FF.forEach(t),L1=p(Hm),pp=i(Hm,"SPAN",{});var jF=r(pp);S1=a(jF,"IFInpaintingSuperResolutionPipeline"),jF.forEach(t),Hm.forEach(t),nm=p(n),H=i(n,"DIV",{class:!0});var Oe=r(H);u(xo.$$.fragment,Oe),R1=p(Oe),we=i(Oe,"DIV",{class:!0});var za=r(we);u(ko.$$.fragment,za),N1=p(za),dp=i(za,"P",{});var xF=r(dp);M1=a(xF,"Function invoked when calling the pipeline for generation."),xF.forEach(t),G1=p(za),u(zt.$$.fragment,za),za.forEach(t),U1=p(Oe),Wt=i(Oe,"DIV",{class:!0});var Ym=r(Wt);u(qo.$$.fragment,Ym),A1=p(Ym),te=i(Ym,"P",{});var Le=r(te);B1=a(Le,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),mp=i(Le,"CODE",{});var kF=r(mp);z1=a(kF,"enable_sequential_cpu_offload"),kF.forEach(t),W1=a(Le,", this method moves one whole model at a time to the GPU when its "),cp=i(Le,"CODE",{});var qF=r(cp);X1=a(qF,"forward"),qF.forEach(t),V1=a(Le,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),gp=i(Le,"CODE",{});var DF=r(gp);H1=a(DF,"enable_sequential_cpu_offload"),DF.forEach(t),Y1=a(Le,", but performance is much better due to the iterative execution of the "),fp=i(Le,"CODE",{});var TF=r(fp);J1=a(TF,"unet"),TF.forEach(t),K1=a(Le,"."),Le.forEach(t),Ym.forEach(t),Q1=p(Oe),Xt=i(Oe,"DIV",{class:!0});var Jm=r(Xt);u(Do.$$.fragment,Jm),Z1=p(Jm),To=i(Jm,"P",{});var Km=r(To);ey=a(Km,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, the pipeline\u2019s
models have their state dicts saved to CPU and then are moved to a `),up=i(Km,"CODE",{});var CF=r(up);ty=a(CF,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),CF.forEach(t),ny=a(Km,"forward` method called."),Km.forEach(t),Jm.forEach(t),oy=p(Oe),Pe=i(Oe,"DIV",{class:!0});var Wa=r(Pe);u(Co.$$.fragment,Wa),ay=p(Wa),_p=i(Wa,"P",{});var OF=r(_p);sy=a(OF,"Encodes the prompt into text encoder hidden states."),OF.forEach(t),iy=p(Wa),j=i(Wa,"P",{});var C=r(j);ry=a(C,"device: ("),hp=i(C,"CODE",{});var LF=r(hp);ly=a(LF,"torch.device"),LF.forEach(t),py=a(C,", "),vp=i(C,"EM",{});var SF=r(vp);dy=a(SF,"optional"),SF.forEach(t),my=a(C,`):
torch device to place the resulting embeddings on
num_images_per_prompt (`),bp=i(C,"CODE",{});var RF=r(bp);cy=a(RF,"int"),RF.forEach(t),gy=a(C,", "),Ip=i(C,"EM",{});var NF=r(Ip);fy=a(NF,"optional"),NF.forEach(t),uy=a(C,`, defaults to 1):
number of images that should be generated per prompt
do_classifier_free_guidance (`),yp=i(C,"CODE",{});var MF=r(yp);_y=a(MF,"bool"),MF.forEach(t),hy=a(C,", "),wp=i(C,"EM",{});var GF=r(wp);vy=a(GF,"optional"),GF.forEach(t),by=a(C,", defaults to "),Pp=i(C,"CODE",{});var UF=r(Pp);Iy=a(UF,"True"),UF.forEach(t),yy=a(C,`):
whether to use classifier free guidance or not
negative_prompt (`),Ep=i(C,"CODE",{});var AF=r(Ep);wy=a(AF,"str"),AF.forEach(t),Py=a(C," or "),Fp=i(C,"CODE",{});var BF=r(Fp);Ey=a(BF,"List[str]"),BF.forEach(t),Fy=a(C,", "),$p=i(C,"EM",{});var zF=r($p);$y=a(zF,"optional"),zF.forEach(t),jy=a(C,`):
The prompt or prompts not to guide the image generation. If not defined, one has to pass
`),jp=i(C,"CODE",{});var WF=r(jp);xy=a(WF,"negative_prompt_embeds"),WF.forEach(t),ky=a(C,". instead. If not defined, one has to pass "),xp=i(C,"CODE",{});var XF=r(xp);qy=a(XF,"negative_prompt_embeds"),XF.forEach(t),Dy=a(C,`. instead.
Ignored when not using guidance (i.e., ignored if `),kp=i(C,"CODE",{});var VF=r(kp);Ty=a(VF,"guidance_scale"),VF.forEach(t),Cy=a(C," is less than "),qp=i(C,"CODE",{});var HF=r(qp);Oy=a(HF,"1"),HF.forEach(t),Ly=a(C,`).
prompt_embeds (`),Dp=i(C,"CODE",{});var YF=r(Dp);Sy=a(YF,"torch.FloatTensor"),YF.forEach(t),Ry=a(C,", "),Tp=i(C,"EM",{});var JF=r(Tp);Ny=a(JF,"optional"),JF.forEach(t),My=a(C,`):
Pre-generated text embeddings. Can be used to easily tweak text inputs, `),Cp=i(C,"EM",{});var KF=r(Cp);Gy=a(KF,"e.g."),KF.forEach(t),Uy=a(C,` prompt weighting. If not
provided, text embeddings will be generated from `),Op=i(C,"CODE",{});var QF=r(Op);Ay=a(QF,"prompt"),QF.forEach(t),By=a(C,` input argument.
negative_prompt_embeds (`),Lp=i(C,"CODE",{});var ZF=r(Lp);zy=a(ZF,"torch.FloatTensor"),ZF.forEach(t),Wy=a(C,", "),Sp=i(C,"EM",{});var e$=r(Sp);Xy=a(e$,"optional"),e$.forEach(t),Vy=a(C,`):
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, `),Rp=i(C,"EM",{});var t$=r(Rp);Hy=a(t$,"e.g."),t$.forEach(t),Yy=a(C,` prompt
weighting. If not provided, negative_prompt_embeds will be generated from `),Np=i(C,"CODE",{});var n$=r(Np);Jy=a(n$,"negative_prompt"),n$.forEach(t),Ky=a(C,` input
argument.`),C.forEach(t),Wa.forEach(t),Oe.forEach(t),this.h()},h(){d(y,"name","hf:doc:metadata"),d(y,"content",JSON.stringify(_$)),d(I,"id","if"),d(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(I,"href","#if"),d(L,"class","relative group"),d(st,"id","overview"),d(st,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(st,"href","#overview"),d(Se,"class","relative group"),d(Yt,"href","https://huggingface.co/stabilityai/stable-diffusion-x4-upscaler"),d(Yt,"rel","nofollow"),d(it,"id","usage"),d(it,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(it,"href","#usage"),d(Re,"class","relative group"),d(Qt,"href","https://huggingface.co/join"),d(Qt,"rel","nofollow"),d(en,"href","https://huggingface.co/DeepFloyd/IF-I-XL-v1.0"),d(en,"rel","nofollow"),d(on,"href","https://huggingface.co/docs/hub/security-tokens#what-are-user-access-tokens"),d(on,"rel","nofollow"),d(Bo,"href","#text-to-image-generation"),d(zo,"href","#text-guided-image-to-image-generation"),d(Wo,"href","#text-guided-inpainting-generation"),d(Xo,"href","#converting-between-different-pipelines"),d(Vo,"href","#optimizing-for-speed"),d(Ho,"href","#optimizing-for-memory"),d(rn,"href","https://huggingface.co/DeepFloyd/IF-I-XL-v1.0"),d(rn,"rel","nofollow"),d(ln,"href","https://huggingface.co/DeepFloyd/IF-I-L-v1.0"),d(ln,"rel","nofollow"),d(pn,"href","https://huggingface.co/DeepFloyd/IF-I-M-v1.0"),d(pn,"rel","nofollow"),d(cn,"href","https://huggingface.co/DeepFloyd/IF-II-L-v1.0"),d(cn,"rel","nofollow"),d(gn,"href","https://huggingface.co/DeepFloyd/IF-II-M-v1.0"),d(gn,"rel","nofollow"),d(un,"href","https://huggingface.co/stabilityai/stable-diffusion-x4-upscaler"),d(un,"rel","nofollow"),o$(Jo.src,Zy="https://img.shields.io/badge/%F0%9F%A4%97%20Hugging%20Face-Spaces-blue")||d(Jo,"src",Zy),d(Jo,"alt","Hugging Face Spaces"),d(_n,"href","https://huggingface.co/spaces/DeepFloyd/IF"),d(_n,"rel","nofollow"),o$(Ko.src,e2="https://colab.research.google.com/assets/colab-badge.svg")||d(Ko,"src",e2),d(Ko,"alt","Open In Colab"),d(hn,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/deepfloyd_if_free_tier_google_colab.ipynb"),d(hn,"rel","nofollow"),d(mt,"id","texttoimage-generation"),d(mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(mt,"href","#texttoimage-generation"),d(Me,"class","relative group"),d(bn,"href","https://huggingface.co/docs/diffusers/optimization/fp16#model-offloading-for-fast-inference-and-memory-savings"),d(bn,"rel","nofollow"),d(gt,"id","text-guided-imagetoimage-generation"),d(gt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(gt,"href","#text-guided-imagetoimage-generation"),d(Ge,"class","relative group"),d(Qo,"href","/docs/diffusers/pr_187/en/api/pipelines/if#diffusers.IFInpaintingPipeline"),d(Zo,"href","/docs/diffusers/pr_187/en/api/pipelines/if#diffusers.IFInpaintingSuperResolutionPipeline"),d(ea,"href","#converting-between-different-pipelines"),d(ft,"id","text-guided-inpainting-generation"),d(ft,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ft,"href","#text-guided-inpainting-generation"),d(Ue,"class","relative group"),d(ta,"href","/docs/diffusers/pr_187/en/api/pipelines/if#diffusers.IFInpaintingPipeline"),d(na,"href","/docs/diffusers/pr_187/en/api/pipelines/if#diffusers.IFInpaintingSuperResolutionPipeline"),d(oa,"href","#converting-between-different-pipelines"),d(ut,"id","converting-between-different-pipelines"),d(ut,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ut,"href","#converting-between-different-pipelines"),d(Ae,"class","relative group"),d(ht,"id","optimizing-for-speed"),d(ht,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ht,"href","#optimizing-for-speed"),d(Be,"class","relative group"),d(ra,"href","../../optimization/torch2.0"),d(It,"id","optimizing-for-memory"),d(It,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(It,"href","#optimizing-for-memory"),d(ze,"class","relative group"),d(yt,"id","available-pipelines"),d(yt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(yt,"href","#available-pipelines"),d(We,"class","relative group"),d(ga,"align","center"),d(Mn,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py"),d(Mn,"rel","nofollow"),d(fa,"align","center"),d(Gn,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if.py"),d(Gn,"rel","nofollow"),d(ua,"align","center"),d(Un,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img.py"),d(Un,"rel","nofollow"),d(_a,"align","center"),d(An,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if_img2img_superresolution.py"),d(An,"rel","nofollow"),d(ha,"align","center"),d(Bn,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting.py"),d(Bn,"rel","nofollow"),d(va,"align","center"),d(zn,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/deepfloyd_if/pipeline_if_inpainting_superresolution.py"),d(zn,"rel","nofollow"),d(ba,"align","center"),d(Pt,"id","diffusers.IFPipeline"),d(Pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Pt,"href","#diffusers.IFPipeline"),d(Ze,"class","relative group"),d(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(jt,"id","diffusers.IFSuperResolutionPipeline"),d(jt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(jt,"href","#diffusers.IFSuperResolutionPipeline"),d(et,"class","relative group"),d(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Dt,"id","diffusers.IFImg2ImgPipeline"),d(Dt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Dt,"href","#diffusers.IFImg2ImgPipeline"),d(tt,"class","relative group"),d(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Lt,"id","diffusers.IFImg2ImgSuperResolutionPipeline"),d(Lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Lt,"href","#diffusers.IFImg2ImgSuperResolutionPipeline"),d(nt,"class","relative group"),d(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Mt,"id","diffusers.IFInpaintingPipeline"),d(Mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Mt,"href","#diffusers.IFInpaintingPipeline"),d(ot,"class","relative group"),d(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(At,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Bt,"id","diffusers.IFInpaintingSuperResolutionPipeline"),d(Bt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Bt,"href","#diffusers.IFInpaintingSuperResolutionPipeline"),d(at,"class","relative group"),d(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(n,m){e(document.head,y),c(n,N,m),c(n,L,m),e(L,I),e(I,S),_(g,S,null),e(L,O),e(L,Ha),e(Ha,Qm),c(n,Bp,m),c(n,Se,m),e(Se,st),e(st,Ya),_(Vt,Ya,null),e(Se,Zm),e(Se,Ja),e(Ja,ec),c(n,zp,m),c(n,No,m),e(No,tc),c(n,Wp,m),c(n,ie,m),e(ie,Ka),e(Ka,nc),e(ie,oc),e(ie,Qa),e(Qa,ac),e(ie,sc),e(ie,Ht),e(Ht,ic),e(Ht,Yt),e(Yt,rc),e(Ht,lc),c(n,Xp,m),c(n,Re,m),e(Re,it),e(it,Za),_(Jt,Za,null),e(Re,pc),e(Re,es),e(es,dc),c(n,Vp,m),c(n,Mo,m),e(Mo,mc),c(n,Hp,m),c(n,re,m),e(re,Kt),e(Kt,cc),e(Kt,Qt),e(Qt,gc),e(Kt,fc),e(re,uc),e(re,Zt),e(Zt,_c),e(Zt,en),e(en,hc),e(Zt,vc),e(re,bc),e(re,Go),e(Go,Ic),e(Go,ts),e(ts,yc),c(n,Yp,m),_(tn,n,m),c(n,Jp,m),c(n,Uo,m),e(Uo,wc),c(n,Kp,m),_(nn,n,m),c(n,Qp,m),c(n,rt,m),e(rt,Pc),e(rt,on),e(on,Ec),e(rt,Fc),c(n,Zp,m),c(n,lt,m),e(lt,$c),e(lt,ns),e(ns,jc),e(lt,xc),c(n,ed,m),_(an,n,m),c(n,td,m),c(n,Ao,m),e(Ao,kc),c(n,nd,m),c(n,G,m),e(G,os),e(os,Bo),e(Bo,qc),e(G,Dc),e(G,as),e(as,zo),e(zo,Tc),e(G,Cc),e(G,ss),e(ss,Wo),e(Wo,Oc),e(G,Lc),e(G,is),e(is,Xo),e(Xo,Sc),e(G,Rc),e(G,rs),e(rs,Vo),e(Vo,Nc),e(G,Mc),e(G,ls),e(ls,Ho),e(Ho,Gc),c(n,od,m),c(n,Yo,m),e(Yo,ps),e(ps,Uc),c(n,ad,m),c(n,le,m),e(le,sn),e(sn,ds),e(ds,ms),e(ms,Ac),e(sn,Bc),e(sn,Ne),e(Ne,cs),e(cs,rn),e(rn,zc),e(Ne,Wc),e(Ne,gs),e(gs,ln),e(ln,Xc),e(Ne,Vc),e(Ne,fs),e(fs,pn),e(pn,Hc),e(le,Yc),e(le,dn),e(dn,us),e(us,_s),e(_s,Jc),e(dn,Kc),e(dn,mn),e(mn,hs),e(hs,cn),e(cn,Qc),e(mn,Zc),e(mn,vs),e(vs,gn),e(gn,eg),e(le,tg),e(le,fn),e(fn,bs),e(bs,Is),e(Is,ng),e(fn,og),e(fn,ys),e(ys,ws),e(ws,un),e(un,ag),c(n,sd,m),c(n,pt,m),e(pt,Ps),e(Ps,sg),e(pt,ig),e(pt,_n),e(_n,Jo),c(n,id,m),c(n,dt,m),e(dt,Es),e(Es,rg),e(dt,lg),e(dt,hn),e(hn,Ko),c(n,rd,m),c(n,Me,m),e(Me,mt),e(mt,Fs),_(vn,Fs,null),e(Me,pg),e(Me,$s),e($s,dg),c(n,ld,m),c(n,ct,m),e(ct,mg),e(ct,bn),e(bn,cg),e(ct,gg),c(n,pd,m),_(In,n,m),c(n,dd,m),c(n,Ge,m),e(Ge,gt),e(gt,js),_(yn,js,null),e(Ge,fg),e(Ge,xs),e(xs,ug),c(n,md,m),c(n,pe,m),e(pe,_g),e(pe,Qo),e(Qo,hg),e(pe,vg),e(pe,Zo),e(Zo,bg),e(pe,Ig),c(n,cd,m),c(n,ae,m),e(ae,ks),e(ks,yg),e(ae,wg),e(ae,qs),e(qs,Pg),e(ae,Eg),e(ae,ea),e(ea,Fg),e(ae,$g),c(n,gd,m),_(wn,n,m),c(n,fd,m),c(n,Ue,m),e(Ue,ft),e(ft,Ds),_(Pn,Ds,null),e(Ue,jg),e(Ue,Ts),e(Ts,xg),c(n,ud,m),c(n,de,m),e(de,kg),e(de,ta),e(ta,qg),e(de,Dg),e(de,na),e(na,Tg),e(de,Cg),c(n,_d,m),c(n,se,m),e(se,Cs),e(Cs,Og),e(se,Lg),e(se,Os),e(Os,Sg),e(se,Rg),e(se,oa),e(oa,Ng),e(se,Mg),c(n,hd,m),_(En,n,m),c(n,vd,m),c(n,Ae,m),e(Ae,ut),e(ut,Ls),_(Fn,Ls,null),e(Ae,Gg),e(Ae,Ss),e(Ss,Ug),c(n,bd,m),c(n,_t,m),e(_t,Ag),e(_t,Rs),e(Rs,Bg),e(_t,zg),c(n,Id,m),_($n,n,m),c(n,yd,m),c(n,Be,m),e(Be,ht),e(ht,Ns),_(jn,Ns,null),e(Be,Wg),e(Be,Ms),e(Ms,Xg),c(n,wd,m),c(n,aa,m),e(aa,Vg),c(n,Pd,m),_(xn,n,m),c(n,Ed,m),c(n,sa,m),e(sa,Hg),c(n,Fd,m),c(n,vt,m),e(vt,Yg),e(vt,Gs),e(Gs,Jg),e(vt,Kg),c(n,$d,m),_(kn,n,m),c(n,jd,m),c(n,bt,m),e(bt,Qg),e(bt,Us),e(Us,Zg),e(bt,ef),c(n,xd,m),_(qn,n,m),c(n,kd,m),c(n,ia,m),e(ia,tf),c(n,qd,m),_(Dn,n,m),c(n,Dd,m),c(n,me,m),e(me,nf),e(me,ra),e(ra,As),e(As,of),e(me,af),e(me,Bs),e(Bs,sf),e(me,rf),c(n,Td,m),_(Tn,n,m),c(n,Cd,m),c(n,ze,m),e(ze,It),e(It,zs),_(Cn,zs,null),e(ze,lf),e(ze,Ws),e(Ws,pf),c(n,Od,m),c(n,la,m),e(la,df),c(n,Ld,m),c(n,pa,m),e(pa,mf),c(n,Sd,m),_(On,n,m),c(n,Rd,m),c(n,da,m),e(da,cf),c(n,Nd,m),_(Ln,n,m),c(n,Md,m),c(n,ma,m),e(ma,gf),c(n,Gd,m),_(Sn,n,m),c(n,Ud,m),c(n,ca,m),e(ca,ff),c(n,Ad,m),_(Rn,n,m),c(n,Bd,m),c(n,We,m),e(We,yt),e(yt,Xs),_(Nn,Xs,null),e(We,uf),e(We,Vs),e(Vs,_f),c(n,zd,m),c(n,wt,m),e(wt,Hs),e(Hs,Xe),e(Xe,Ys),e(Ys,hf),e(Xe,vf),e(Xe,Js),e(Js,bf),e(Xe,If),e(Xe,ga),e(ga,yf),e(wt,wf),e(wt,A),e(A,Ve),e(Ve,Ks),e(Ks,Mn),e(Mn,Pf),e(Ve,Ef),e(Ve,Qs),e(Qs,Zs),e(Zs,Ff),e(Ve,$f),e(Ve,fa),e(fa,jf),e(A,xf),e(A,He),e(He,ei),e(ei,Gn),e(Gn,kf),e(He,qf),e(He,ti),e(ti,ni),e(ni,Df),e(He,Tf),e(He,ua),e(ua,Cf),e(A,Of),e(A,Ye),e(Ye,oi),e(oi,Un),e(Un,Lf),e(Ye,Sf),e(Ye,ai),e(ai,si),e(si,Rf),e(Ye,Nf),e(Ye,_a),e(_a,Mf),e(A,Gf),e(A,Je),e(Je,ii),e(ii,An),e(An,Uf),e(Je,Af),e(Je,ri),e(ri,li),e(li,Bf),e(Je,zf),e(Je,ha),e(ha,Wf),e(A,Xf),e(A,Ke),e(Ke,pi),e(pi,Bn),e(Bn,Vf),e(Ke,Hf),e(Ke,di),e(di,mi),e(mi,Yf),e(Ke,Jf),e(Ke,va),e(va,Kf),e(A,Qf),e(A,Qe),e(Qe,ci),e(ci,zn),e(zn,Zf),e(Qe,eu),e(Qe,gi),e(gi,fi),e(fi,tu),e(Qe,nu),e(Qe,ba),e(ba,ou),c(n,Wd,m),c(n,Ze,m),e(Ze,Pt),e(Pt,ui),_(Wn,ui,null),e(Ze,au),e(Ze,_i),e(_i,su),c(n,Xd,m),c(n,B,m),_(Xn,B,null),e(B,iu),e(B,ce),_(Vn,ce,null),e(ce,ru),e(ce,hi),e(hi,lu),e(ce,pu),_(Et,ce,null),e(B,du),e(B,Ft),_(Hn,Ft,null),e(Ft,mu),e(Ft,J),e(J,cu),e(J,vi),e(vi,gu),e(J,fu),e(J,bi),e(bi,uu),e(J,_u),e(J,Ii),e(Ii,hu),e(J,vu),e(J,yi),e(yi,bu),e(J,Iu),e(B,yu),e(B,$t),_(Yn,$t,null),e($t,wu),e($t,Jn),e(Jn,Pu),e(Jn,wi),e(wi,Eu),e(Jn,Fu),e(B,$u),e(B,ge),_(Kn,ge,null),e(ge,ju),e(ge,Pi),e(Pi,xu),e(ge,ku),e(ge,w),e(w,qu),e(w,Ei),e(Ei,Du),e(w,Tu),e(w,Fi),e(Fi,Cu),e(w,Ou),e(w,$i),e($i,Lu),e(w,Su),e(w,ji),e(ji,Ru),e(w,Nu),e(w,xi),e(xi,Mu),e(w,Gu),e(w,ki),e(ki,Uu),e(w,Au),e(w,qi),e(qi,Bu),e(w,zu),e(w,Di),e(Di,Wu),e(w,Xu),e(w,Ti),e(Ti,Vu),e(w,Hu),e(w,Ci),e(Ci,Yu),e(w,Ju),e(w,Oi),e(Oi,Ku),e(w,Qu),e(w,Li),e(Li,Zu),e(w,e_),e(w,Si),e(Si,t_),e(w,n_),e(w,Ri),e(Ri,o_),e(w,a_),e(w,Ni),e(Ni,s_),e(w,i_),e(w,Mi),e(Mi,r_),e(w,l_),e(w,Gi),e(Gi,p_),e(w,d_),e(w,Ui),e(Ui,m_),e(w,c_),e(w,Ai),e(Ai,g_),e(w,f_),e(w,Bi),e(Bi,u_),e(w,__),e(w,zi),e(zi,h_),e(w,v_),e(w,Wi),e(Wi,b_),e(w,I_),c(n,Vd,m),c(n,et,m),e(et,jt),e(jt,Xi),_(Qn,Xi,null),e(et,y_),e(et,Vi),e(Vi,w_),c(n,Hd,m),c(n,z,m),_(Zn,z,null),e(z,P_),e(z,fe),_(eo,fe,null),e(fe,E_),e(fe,Hi),e(Hi,F_),e(fe,$_),_(xt,fe,null),e(z,j_),e(z,kt),_(to,kt,null),e(kt,x_),e(kt,K),e(K,k_),e(K,Yi),e(Yi,q_),e(K,D_),e(K,Ji),e(Ji,T_),e(K,C_),e(K,Ki),e(Ki,O_),e(K,L_),e(K,Qi),e(Qi,S_),e(K,R_),e(z,N_),e(z,qt),_(no,qt,null),e(qt,M_),e(qt,oo),e(oo,G_),e(oo,Zi),e(Zi,U_),e(oo,A_),e(z,B_),e(z,ue),_(ao,ue,null),e(ue,z_),e(ue,er),e(er,W_),e(ue,X_),e(ue,P),e(P,V_),e(P,tr),e(tr,H_),e(P,Y_),e(P,nr),e(nr,J_),e(P,K_),e(P,or),e(or,Q_),e(P,Z_),e(P,ar),e(ar,eh),e(P,th),e(P,sr),e(sr,nh),e(P,oh),e(P,ir),e(ir,ah),e(P,sh),e(P,rr),e(rr,ih),e(P,rh),e(P,lr),e(lr,lh),e(P,ph),e(P,pr),e(pr,dh),e(P,mh),e(P,dr),e(dr,ch),e(P,gh),e(P,mr),e(mr,fh),e(P,uh),e(P,cr),e(cr,_h),e(P,hh),e(P,gr),e(gr,vh),e(P,bh),e(P,fr),e(fr,Ih),e(P,yh),e(P,ur),e(ur,wh),e(P,Ph),e(P,_r),e(_r,Eh),e(P,Fh),e(P,hr),e(hr,$h),e(P,jh),e(P,vr),e(vr,xh),e(P,kh),e(P,br),e(br,qh),e(P,Dh),e(P,Ir),e(Ir,Th),e(P,Ch),e(P,yr),e(yr,Oh),e(P,Lh),e(P,wr),e(wr,Sh),e(P,Rh),c(n,Yd,m),c(n,tt,m),e(tt,Dt),e(Dt,Pr),_(so,Pr,null),e(tt,Nh),e(tt,Er),e(Er,Mh),c(n,Jd,m),c(n,W,m),_(io,W,null),e(W,Gh),e(W,_e),_(ro,_e,null),e(_e,Uh),e(_e,Fr),e(Fr,Ah),e(_e,Bh),_(Tt,_e,null),e(W,zh),e(W,Ct),_(lo,Ct,null),e(Ct,Wh),e(Ct,Q),e(Q,Xh),e(Q,$r),e($r,Vh),e(Q,Hh),e(Q,jr),e(jr,Yh),e(Q,Jh),e(Q,xr),e(xr,Kh),e(Q,Qh),e(Q,kr),e(kr,Zh),e(Q,ev),e(W,tv),e(W,Ot),_(po,Ot,null),e(Ot,nv),e(Ot,mo),e(mo,ov),e(mo,qr),e(qr,av),e(mo,sv),e(W,iv),e(W,he),_(co,he,null),e(he,rv),e(he,Dr),e(Dr,lv),e(he,pv),e(he,E),e(E,dv),e(E,Tr),e(Tr,mv),e(E,cv),e(E,Cr),e(Cr,gv),e(E,fv),e(E,Or),e(Or,uv),e(E,_v),e(E,Lr),e(Lr,hv),e(E,vv),e(E,Sr),e(Sr,bv),e(E,Iv),e(E,Rr),e(Rr,yv),e(E,wv),e(E,Nr),e(Nr,Pv),e(E,Ev),e(E,Mr),e(Mr,Fv),e(E,$v),e(E,Gr),e(Gr,jv),e(E,xv),e(E,Ur),e(Ur,kv),e(E,qv),e(E,Ar),e(Ar,Dv),e(E,Tv),e(E,Br),e(Br,Cv),e(E,Ov),e(E,zr),e(zr,Lv),e(E,Sv),e(E,Wr),e(Wr,Rv),e(E,Nv),e(E,Xr),e(Xr,Mv),e(E,Gv),e(E,Vr),e(Vr,Uv),e(E,Av),e(E,Hr),e(Hr,Bv),e(E,zv),e(E,Yr),e(Yr,Wv),e(E,Xv),e(E,Jr),e(Jr,Vv),e(E,Hv),e(E,Kr),e(Kr,Yv),e(E,Jv),e(E,Qr),e(Qr,Kv),e(E,Qv),e(E,Zr),e(Zr,Zv),e(E,eb),c(n,Kd,m),c(n,nt,m),e(nt,Lt),e(Lt,el),_(go,el,null),e(nt,tb),e(nt,tl),e(tl,nb),c(n,Qd,m),c(n,X,m),_(fo,X,null),e(X,ob),e(X,ve),_(uo,ve,null),e(ve,ab),e(ve,nl),e(nl,sb),e(ve,ib),_(St,ve,null),e(X,rb),e(X,Rt),_(_o,Rt,null),e(Rt,lb),e(Rt,Z),e(Z,pb),e(Z,ol),e(ol,db),e(Z,mb),e(Z,al),e(al,cb),e(Z,gb),e(Z,sl),e(sl,fb),e(Z,ub),e(Z,il),e(il,_b),e(Z,hb),e(X,vb),e(X,Nt),_(ho,Nt,null),e(Nt,bb),e(Nt,vo),e(vo,Ib),e(vo,rl),e(rl,yb),e(vo,wb),e(X,Pb),e(X,be),_(bo,be,null),e(be,Eb),e(be,ll),e(ll,Fb),e(be,$b),e(be,F),e(F,jb),e(F,pl),e(pl,xb),e(F,kb),e(F,dl),e(dl,qb),e(F,Db),e(F,ml),e(ml,Tb),e(F,Cb),e(F,cl),e(cl,Ob),e(F,Lb),e(F,gl),e(gl,Sb),e(F,Rb),e(F,fl),e(fl,Nb),e(F,Mb),e(F,ul),e(ul,Gb),e(F,Ub),e(F,_l),e(_l,Ab),e(F,Bb),e(F,hl),e(hl,zb),e(F,Wb),e(F,vl),e(vl,Xb),e(F,Vb),e(F,bl),e(bl,Hb),e(F,Yb),e(F,Il),e(Il,Jb),e(F,Kb),e(F,yl),e(yl,Qb),e(F,Zb),e(F,wl),e(wl,eI),e(F,tI),e(F,Pl),e(Pl,nI),e(F,oI),e(F,El),e(El,aI),e(F,sI),e(F,Fl),e(Fl,iI),e(F,rI),e(F,$l),e($l,lI),e(F,pI),e(F,jl),e(jl,dI),e(F,mI),e(F,xl),e(xl,cI),e(F,gI),e(F,kl),e(kl,fI),e(F,uI),e(F,ql),e(ql,_I),e(F,hI),c(n,Zd,m),c(n,ot,m),e(ot,Mt),e(Mt,Dl),_(Io,Dl,null),e(ot,vI),e(ot,Tl),e(Tl,bI),c(n,em,m),c(n,V,m),_(yo,V,null),e(V,II),e(V,Ie),_(wo,Ie,null),e(Ie,yI),e(Ie,Cl),e(Cl,wI),e(Ie,PI),_(Gt,Ie,null),e(V,EI),e(V,Ut),_(Po,Ut,null),e(Ut,FI),e(Ut,ee),e(ee,$I),e(ee,Ol),e(Ol,jI),e(ee,xI),e(ee,Ll),e(Ll,kI),e(ee,qI),e(ee,Sl),e(Sl,DI),e(ee,TI),e(ee,Rl),e(Rl,CI),e(ee,OI),e(V,LI),e(V,At),_(Eo,At,null),e(At,SI),e(At,Fo),e(Fo,RI),e(Fo,Nl),e(Nl,NI),e(Fo,MI),e(V,GI),e(V,ye),_($o,ye,null),e(ye,UI),e(ye,Ml),e(Ml,AI),e(ye,BI),e(ye,$),e($,zI),e($,Gl),e(Gl,WI),e($,XI),e($,Ul),e(Ul,VI),e($,HI),e($,Al),e(Al,YI),e($,JI),e($,Bl),e(Bl,KI),e($,QI),e($,zl),e(zl,ZI),e($,e1),e($,Wl),e(Wl,t1),e($,n1),e($,Xl),e(Xl,o1),e($,a1),e($,Vl),e(Vl,s1),e($,i1),e($,Hl),e(Hl,r1),e($,l1),e($,Yl),e(Yl,p1),e($,d1),e($,Jl),e(Jl,m1),e($,c1),e($,Kl),e(Kl,g1),e($,f1),e($,Ql),e(Ql,u1),e($,_1),e($,Zl),e(Zl,h1),e($,v1),e($,ep),e(ep,b1),e($,I1),e($,tp),e(tp,y1),e($,w1),e($,np),e(np,P1),e($,E1),e($,op),e(op,F1),e($,$1),e($,ap),e(ap,j1),e($,x1),e($,sp),e(sp,k1),e($,q1),e($,ip),e(ip,D1),e($,T1),e($,rp),e(rp,C1),e($,O1),c(n,tm,m),c(n,at,m),e(at,Bt),e(Bt,lp),_(jo,lp,null),e(at,L1),e(at,pp),e(pp,S1),c(n,nm,m),c(n,H,m),_(xo,H,null),e(H,R1),e(H,we),_(ko,we,null),e(we,N1),e(we,dp),e(dp,M1),e(we,G1),_(zt,we,null),e(H,U1),e(H,Wt),_(qo,Wt,null),e(Wt,A1),e(Wt,te),e(te,B1),e(te,mp),e(mp,z1),e(te,W1),e(te,cp),e(cp,X1),e(te,V1),e(te,gp),e(gp,H1),e(te,Y1),e(te,fp),e(fp,J1),e(te,K1),e(H,Q1),e(H,Xt),_(Do,Xt,null),e(Xt,Z1),e(Xt,To),e(To,ey),e(To,up),e(up,ty),e(To,ny),e(H,oy),e(H,Pe),_(Co,Pe,null),e(Pe,ay),e(Pe,_p),e(_p,sy),e(Pe,iy),e(Pe,j),e(j,ry),e(j,hp),e(hp,ly),e(j,py),e(j,vp),e(vp,dy),e(j,my),e(j,bp),e(bp,cy),e(j,gy),e(j,Ip),e(Ip,fy),e(j,uy),e(j,yp),e(yp,_y),e(j,hy),e(j,wp),e(wp,vy),e(j,by),e(j,Pp),e(Pp,Iy),e(j,yy),e(j,Ep),e(Ep,wy),e(j,Py),e(j,Fp),e(Fp,Ey),e(j,Fy),e(j,$p),e($p,$y),e(j,jy),e(j,jp),e(jp,xy),e(j,ky),e(j,xp),e(xp,qy),e(j,Dy),e(j,kp),e(kp,Ty),e(j,Cy),e(j,qp),e(qp,Oy),e(j,Ly),e(j,Dp),e(Dp,Sy),e(j,Ry),e(j,Tp),e(Tp,Ny),e(j,My),e(j,Cp),e(Cp,Gy),e(j,Uy),e(j,Op),e(Op,Ay),e(j,By),e(j,Lp),e(Lp,zy),e(j,Wy),e(j,Sp),e(Sp,Xy),e(j,Vy),e(j,Rp),e(Rp,Hy),e(j,Yy),e(j,Np),e(Np,Jy),e(j,Ky),om=!0},p(n,[m]){const Oo={};m&2&&(Oo.$$scope={dirty:m,ctx:n}),Et.$set(Oo);const Mp={};m&2&&(Mp.$$scope={dirty:m,ctx:n}),xt.$set(Mp);const Gp={};m&2&&(Gp.$$scope={dirty:m,ctx:n}),Tt.$set(Gp);const Up={};m&2&&(Up.$$scope={dirty:m,ctx:n}),St.$set(Up);const Lo={};m&2&&(Lo.$$scope={dirty:m,ctx:n}),Gt.$set(Lo);const Ap={};m&2&&(Ap.$$scope={dirty:m,ctx:n}),zt.$set(Ap)},i(n){om||(h(g.$$.fragment,n),h(Vt.$$.fragment,n),h(Jt.$$.fragment,n),h(tn.$$.fragment,n),h(nn.$$.fragment,n),h(an.$$.fragment,n),h(vn.$$.fragment,n),h(In.$$.fragment,n),h(yn.$$.fragment,n),h(wn.$$.fragment,n),h(Pn.$$.fragment,n),h(En.$$.fragment,n),h(Fn.$$.fragment,n),h($n.$$.fragment,n),h(jn.$$.fragment,n),h(xn.$$.fragment,n),h(kn.$$.fragment,n),h(qn.$$.fragment,n),h(Dn.$$.fragment,n),h(Tn.$$.fragment,n),h(Cn.$$.fragment,n),h(On.$$.fragment,n),h(Ln.$$.fragment,n),h(Sn.$$.fragment,n),h(Rn.$$.fragment,n),h(Nn.$$.fragment,n),h(Wn.$$.fragment,n),h(Xn.$$.fragment,n),h(Vn.$$.fragment,n),h(Et.$$.fragment,n),h(Hn.$$.fragment,n),h(Yn.$$.fragment,n),h(Kn.$$.fragment,n),h(Qn.$$.fragment,n),h(Zn.$$.fragment,n),h(eo.$$.fragment,n),h(xt.$$.fragment,n),h(to.$$.fragment,n),h(no.$$.fragment,n),h(ao.$$.fragment,n),h(so.$$.fragment,n),h(io.$$.fragment,n),h(ro.$$.fragment,n),h(Tt.$$.fragment,n),h(lo.$$.fragment,n),h(po.$$.fragment,n),h(co.$$.fragment,n),h(go.$$.fragment,n),h(fo.$$.fragment,n),h(uo.$$.fragment,n),h(St.$$.fragment,n),h(_o.$$.fragment,n),h(ho.$$.fragment,n),h(bo.$$.fragment,n),h(Io.$$.fragment,n),h(yo.$$.fragment,n),h(wo.$$.fragment,n),h(Gt.$$.fragment,n),h(Po.$$.fragment,n),h(Eo.$$.fragment,n),h($o.$$.fragment,n),h(jo.$$.fragment,n),h(xo.$$.fragment,n),h(ko.$$.fragment,n),h(zt.$$.fragment,n),h(qo.$$.fragment,n),h(Do.$$.fragment,n),h(Co.$$.fragment,n),om=!0)},o(n){v(g.$$.fragment,n),v(Vt.$$.fragment,n),v(Jt.$$.fragment,n),v(tn.$$.fragment,n),v(nn.$$.fragment,n),v(an.$$.fragment,n),v(vn.$$.fragment,n),v(In.$$.fragment,n),v(yn.$$.fragment,n),v(wn.$$.fragment,n),v(Pn.$$.fragment,n),v(En.$$.fragment,n),v(Fn.$$.fragment,n),v($n.$$.fragment,n),v(jn.$$.fragment,n),v(xn.$$.fragment,n),v(kn.$$.fragment,n),v(qn.$$.fragment,n),v(Dn.$$.fragment,n),v(Tn.$$.fragment,n),v(Cn.$$.fragment,n),v(On.$$.fragment,n),v(Ln.$$.fragment,n),v(Sn.$$.fragment,n),v(Rn.$$.fragment,n),v(Nn.$$.fragment,n),v(Wn.$$.fragment,n),v(Xn.$$.fragment,n),v(Vn.$$.fragment,n),v(Et.$$.fragment,n),v(Hn.$$.fragment,n),v(Yn.$$.fragment,n),v(Kn.$$.fragment,n),v(Qn.$$.fragment,n),v(Zn.$$.fragment,n),v(eo.$$.fragment,n),v(xt.$$.fragment,n),v(to.$$.fragment,n),v(no.$$.fragment,n),v(ao.$$.fragment,n),v(so.$$.fragment,n),v(io.$$.fragment,n),v(ro.$$.fragment,n),v(Tt.$$.fragment,n),v(lo.$$.fragment,n),v(po.$$.fragment,n),v(co.$$.fragment,n),v(go.$$.fragment,n),v(fo.$$.fragment,n),v(uo.$$.fragment,n),v(St.$$.fragment,n),v(_o.$$.fragment,n),v(ho.$$.fragment,n),v(bo.$$.fragment,n),v(Io.$$.fragment,n),v(yo.$$.fragment,n),v(wo.$$.fragment,n),v(Gt.$$.fragment,n),v(Po.$$.fragment,n),v(Eo.$$.fragment,n),v($o.$$.fragment,n),v(jo.$$.fragment,n),v(xo.$$.fragment,n),v(ko.$$.fragment,n),v(zt.$$.fragment,n),v(qo.$$.fragment,n),v(Do.$$.fragment,n),v(Co.$$.fragment,n),om=!1},d(n){t(y),n&&t(N),n&&t(L),b(g),n&&t(Bp),n&&t(Se),b(Vt),n&&t(zp),n&&t(No),n&&t(Wp),n&&t(ie),n&&t(Xp),n&&t(Re),b(Jt),n&&t(Vp),n&&t(Mo),n&&t(Hp),n&&t(re),n&&t(Yp),b(tn,n),n&&t(Jp),n&&t(Uo),n&&t(Kp),b(nn,n),n&&t(Qp),n&&t(rt),n&&t(Zp),n&&t(lt),n&&t(ed),b(an,n),n&&t(td),n&&t(Ao),n&&t(nd),n&&t(G),n&&t(od),n&&t(Yo),n&&t(ad),n&&t(le),n&&t(sd),n&&t(pt),n&&t(id),n&&t(dt),n&&t(rd),n&&t(Me),b(vn),n&&t(ld),n&&t(ct),n&&t(pd),b(In,n),n&&t(dd),n&&t(Ge),b(yn),n&&t(md),n&&t(pe),n&&t(cd),n&&t(ae),n&&t(gd),b(wn,n),n&&t(fd),n&&t(Ue),b(Pn),n&&t(ud),n&&t(de),n&&t(_d),n&&t(se),n&&t(hd),b(En,n),n&&t(vd),n&&t(Ae),b(Fn),n&&t(bd),n&&t(_t),n&&t(Id),b($n,n),n&&t(yd),n&&t(Be),b(jn),n&&t(wd),n&&t(aa),n&&t(Pd),b(xn,n),n&&t(Ed),n&&t(sa),n&&t(Fd),n&&t(vt),n&&t($d),b(kn,n),n&&t(jd),n&&t(bt),n&&t(xd),b(qn,n),n&&t(kd),n&&t(ia),n&&t(qd),b(Dn,n),n&&t(Dd),n&&t(me),n&&t(Td),b(Tn,n),n&&t(Cd),n&&t(ze),b(Cn),n&&t(Od),n&&t(la),n&&t(Ld),n&&t(pa),n&&t(Sd),b(On,n),n&&t(Rd),n&&t(da),n&&t(Nd),b(Ln,n),n&&t(Md),n&&t(ma),n&&t(Gd),b(Sn,n),n&&t(Ud),n&&t(ca),n&&t(Ad),b(Rn,n),n&&t(Bd),n&&t(We),b(Nn),n&&t(zd),n&&t(wt),n&&t(Wd),n&&t(Ze),b(Wn),n&&t(Xd),n&&t(B),b(Xn),b(Vn),b(Et),b(Hn),b(Yn),b(Kn),n&&t(Vd),n&&t(et),b(Qn),n&&t(Hd),n&&t(z),b(Zn),b(eo),b(xt),b(to),b(no),b(ao),n&&t(Yd),n&&t(tt),b(so),n&&t(Jd),n&&t(W),b(io),b(ro),b(Tt),b(lo),b(po),b(co),n&&t(Kd),n&&t(nt),b(go),n&&t(Qd),n&&t(X),b(fo),b(uo),b(St),b(_o),b(ho),b(bo),n&&t(Zd),n&&t(ot),b(Io),n&&t(em),n&&t(V),b(yo),b(wo),b(Gt),b(Po),b(Eo),b($o),n&&t(tm),n&&t(at),b(jo),n&&t(nm),n&&t(H),b(xo),b(ko),b(zt),b(qo),b(Do),b(Co)}}}const _$={local:"if",sections:[{local:"overview",title:"Overview"},{local:"usage",sections:[{local:"texttoimage-generation",title:"Text-to-Image Generation"},{local:"text-guided-imagetoimage-generation",title:"Text Guided Image-to-Image Generation"},{local:"text-guided-inpainting-generation",title:"Text Guided Inpainting Generation"},{local:"converting-between-different-pipelines",title:"Converting between different pipelines"},{local:"optimizing-for-speed",title:"Optimizing for speed"},{local:"optimizing-for-memory",title:"Optimizing for memory"}],title:"Usage"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"diffusers.IFPipeline",title:"IFPipeline"},{local:"diffusers.IFSuperResolutionPipeline",title:"IFSuperResolutionPipeline"},{local:"diffusers.IFImg2ImgPipeline",title:"IFImg2ImgPipeline"},{local:"diffusers.IFImg2ImgSuperResolutionPipeline",title:"IFImg2ImgSuperResolutionPipeline"},{local:"diffusers.IFInpaintingPipeline",title:"IFInpaintingPipeline"},{local:"diffusers.IFInpaintingSuperResolutionPipeline",title:"IFInpaintingSuperResolutionPipeline"}],title:"IF"};function h$(Y){return l$(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class P$ extends a${constructor(y){super();s$(this,y,h$,u$,i$,{})}}export{P$ as default,_$ as metadata};
